<%@ LANGUAGE="VBSCRIPT" %>
<%  Option Explicit  %>
<!-- #include file="inc/globals.asp" -->
<%

'set return page
returnPage = lookupPageName()

'declare vars
Dim templateID, templateCode
Dim metaKeywords, metaDescription
Dim contentID, contentName, contentTitle, contentHeading, contentBody, publishedDate, pageTextItemsValues
Dim selectedDateStart, selectedDateEnd
Dim selectedDateStartDay, selectedDateStartMonth, selectedDateStartYear
Dim selectedDateEndDay, selectedDateEndMonth, selectedDateEndYear
Dim startDate, endDate
Dim contentError, errorMsg
Dim submitted
Dim c_parentIDs, c_ParentNames, c_contentID, c_i


'init error flag
contentError = false

'get submitted flag
submitted = isTextValid(request.form("submitted"))

' Load page details
initPage()

'has the form been submitted
if submitted = true then

  'get calendar dates
  selectedDateStartDay = request.form("selectedDateStartDay")
  selectedDateStartMonth = request.form("selectedDateStartMonth")
  selectedDateStartYear = request.form("selectedDateStartYear")

  selectedDateEndDay = request.form("selectedDateEndDay")
  selectedDateEndMonth = request.form("selectedDateEndMonth")
  selectedDateEndYear = request.form("selectedDateEndYear")

  selectedDateStart = request.form("selectedDateStartDay")&" "&MonthName(request.form("selectedDateStartMonth"))&" "&request.form("selectedDateStartYear")
  selectedDateEnd = request.form("selectedDateEndDay")&" "&MonthName(request.form("selectedDateEndMonth"))&" "&request.form("selectedDateEndYear")

  'validate dates
  if not isDate(selectedDateStart) then
    ' Invalid start date
    errorMsg = errorMsg & "<li>" & pageTextItemsValues(3) & "</li>"
  end if
  if not isDate(selectedDateEnd) then
    ' Invalid end date
    errorMsg = errorMsg & "<li>" & pageTextItemsValues(4) & "</li>"
  end if

  'any error messages?
  if isTextValid(errorMsg) = false then
    'no -> convert to dates from strings
    selectedDateStart = CDate(selectedDateStart)
    selectedDateEnd = CDate(selectedDateEnd&" 23:59:59")

    if selectedDateEnd < selectedDateStart then
      ' start date is after end date
      errorMsg = errorMsg & "<li>" & pageTextItemsValues(5) & "</li>"
    end if
  end if

else

  'get todays date
  selectedDateStart = date()
  '1 month ahead
  selectedDateEnd = CDate(dateAdd("m",1,date())&" 23:59:59")

  selectedDateStartDay = day(selectedDateStart)
  selectedDateStartMonth = month(selectedDateStart)
  selectedDateStartYear = year(selectedDateStart)

  selectedDateEndDay = day(selectedDateEnd)
  selectedDateEndMonth = month(selectedDateEnd)
  selectedDateEndYear = year(selectedDateEnd)

end if

'load calendar data into content vars
loadcalendarData()

'load template
loadPageTemplate()


Sub initPage()
  'loads initial page details
  if dMode <> true then on error resume next
  
  Dim ip_SQLQuery, ip_ds

  'get rs of page details
  ip_SQLQuery = "SELECT tblPrefs_pages.pagetemplateID, tblPrefs_pages_languages.pageContentTitle, tblPrefs_pages_languages.pageContentHeading, tblPrefs_pages_languages.pageTextItemsValues FROM tblPrefs_pages INNER JOIN tblPrefs_pages_languages ON tblPrefs_pages.prefPageID = tblPrefs_pages_languages.prefPageID WHERE (((tblPrefs_pages.itemName)='calendar') AND ((tblPrefs_pages_languages.languageID)=" & session(sessionPrefix & "aCMS_languageID") & "));"
  Set ip_ds = objConn.Execute(ip_SQLQuery)
  
  if not ip_ds.BOF AND not ip_ds.EOF then
    templateID = ip_ds("pagetemplateID")
    contentTitle = ip_ds("pageContentTitle")
    contentHeading = ip_ds("pageContentHeading")
    pageTextItemsValues = ip_ds("pageTextItemsValues")
    if isTextValid(pageTextItemsValues) then pageTextItemsValues = split(pageTextItemsValues, "|**|")
  else
    templateID = 0
  end if
  
  'close and destroy rs object
  ip_ds.close
  Set ip_ds = Nothing

End Sub

Sub loadcalendarData()
  'loads calendar data into content string
  if dMode <> true then on error resume next

  'declare vars
  Dim lcd_SQLQuery, lcd_ds, lcd_currentDate, lcd_endDate

  'get calendar form at least
  contentBody = contentBody & returncalendarForm

  'has an error occurred?
  if isTextValid(errorMsg) = true then
    'yes -> skip rs and display error

    contentBody = contentBody & errorMsg

  else
    'no -> ok to proceed

    'build and execute sql to get calendar items
    lcd_SQLQuery = "SELECT cEvent, cDescription, cDateTime, cMinutes, cURL FROM tblCalendar WHERE cDateTime >= " & prepDate(selectedDateStart) & " AND cDateTime <= " & prepDate(selectedDateEnd) & " ORDER BY cDateTime ASC;"
    Set lcd_ds = objConn.Execute(lcd_SQLQuery)

    'were any records returned?
    if not lcd_ds.EOF and not lcd_ds.BOF then

      contentBody = contentBody & "<table cellpadding=""5"" cellspacing=""0"" border=""0"">"

      do until lcd_ds.EOF
        'first/new date

        'should the date heading be displayed
        if not day(lcd_currentDate)&month(lcd_currentDate)&year(lcd_currentDate) = day(lcd_ds("cDateTime"))&month(lcd_ds("cDateTime"))&year(lcd_ds("cDateTime")) then
          'set date
          lcd_currentDate = lcd_ds("cDateTime")

          'output current date as line
          contentBody = contentBody & "<tr><td colspan=""2"" class=""bodyText""><b>" & day(lcd_currentDate) & "&nbsp;" & Left(monthName(month(lcd_currentDate)),3) & "&nbsp;" & year(lcd_currentDate) & "</b></td></tr>" & vbCr
        else
          'set date
          lcd_currentDate = lcd_ds("cDateTime")
        end if

        if isNumberValid(lcd_ds("cMinutes")) = true and lstr(lcd_ds("cMinutes"),"0") = false then
          lcd_endDate = dateAdd("n",lcd_ds("cMinutes"),lcd_currentDate)
        else
          lcd_endDate = lcd_currentDate
        end if

        'display start time
        if (hour(lcd_currentDate) = 0 AND minute(lcd_currentDate) = 1 AND second(lcd_currentDate) = 2) then
          contentBody = contentBody & "<tr><td valign=""top"" class=""bodyText""><nobr>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"


        else
          contentBody = contentBody & "<tr><td valign=""top"" class=""bodyText""><nobr>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" & minDigits(convertSimpleTime(hour(lcd_currentDate)),2) & ":" & minDigits(minute(lcd_currentDate),2) & "&nbsp;" & displayAmPm(hour(lcd_currentDate))

          'display end time if different to start
          if not lcd_endDate = lcd_currentDate then
            contentBody = contentBody & "&nbsp;-&nbsp;" & minDigits(convertSimpleTime(hour(lcd_endDate)),2) & ":" & minDigits(minute(lcd_endDate),2) & "&nbsp;" & displayAmPm(hour(lcd_endDate))
          end if
        end if

        contentBody = contentBody & "</nobr></td><td class=""bodyText"">"

        'include link if url present
        if isTextValid(lcd_ds("cURL")) = true then
          contentBody = contentBody & "<a href=""" & lcd_ds("cURL") & """>"
        end if

        'display event heading
        contentBody = contentBody & "<b>" & htmlEncode(lcd_ds("cEvent")) & "</b>"

        'close link
        if isTextValid(lcd_ds("cURL")) = true then
          contentBody = contentBody & "</a>"
        end if

        'display description
        if isTextValid(lcd_ds("cDescription")) = true then
          contentBody = contentBody & "<br>" & htmlEncode(lcd_ds("cDescription")) & vbCr
        end if

        contentBody = contentBody & "</td></tr>" & vbCr

        lcd_ds.MoveNext
      loop
      contentBody = contentBody & "</table>"

    else
      ' No entries founnd
      contentBody = contentBody & "<li>" & pageTextItemsValues(2)

    end if

    'close and destroy rs
    lcd_ds.Close
    Set lcd_ds = Nothing

  end if

  contentBody = "<table cellpadding=""0"" cellspacing=""0"" border=""0""><tr><td width=""15""><img src=""img/spacer.gif"" width=""15"" height=""1"" border=""0""></td><td align=""left"" class=""bodyText"">" & contentBody & "</td></tr></table>"

  'error recording
  recordError err.number, err.description, err.source
  
End Sub

Function returncalendarForm()
  'loads calendar data into content string
  if dMode <> true then on error resume next

  'declare vars
  Dim rcf_i, rcf_out, rcf_lastYear, rcf_firstYear

  'get years
  rcf_firstYear = returnSQLFn("min", "Year(cDateTime)", "tblCalendar")
  rcf_lastYear = returnSQLFn("max", "Year(cDateTime)", "tblCalendar")

  if rcf_firstYear = 0 then rcf_firstYear = year(now())
  if rcf_lastYear = 0 then rcf_lastYear = year(now())  

  if rcf_firstYear > year(date()) then rcf_firstYear = year(date())
  if lstr(selectedDateEndMonth,"1") = true then rcf_lastYear = rcf_lastYear + 1

  if isNumberValid(rcf_firstYear) = false then
    'must be no records in the db, set to current year
    rcf_firstYear = year(date())
    rcf_lastYear = rcf_firstYear
  end if

  rcf_out = "<form method=""post"" name=""calendar"" onsubmit=""return checkSubmit();"" style=""display: inline;"">" & _
            "<table cellspacing=""5"" cellspacing=""0"" border=""0"">" & _
            "<tr>" & _
            "<td><span class=""bodyText"">" & pageTextItemsValues(0) & "</span></td>" & _
            "<td><select name=""selectedDateStartDay"">"

  for rcf_i = 1 to 31
    if cstr(""&selectedDateStartDay) = cstr(""&rcf_i) then
      rcf_out = rcf_out & "<option value=" & rcf_i & " selected>" & rcf_i & "</option>" & vbcr
    else
      rcf_out = rcf_out & "<option value=" & rcf_i & ">" & rcf_i & "</option>" & vbcr
    end if
  next 'rcf_i

  rcf_out = rcf_out & "</select><select name=""selectedDateStartMonth"">"

  for rcf_i = 1 to 12
    if cstr(""&selectedDateStartMonth) = cstr(""&rcf_i) then
      rcf_out = rcf_out & "<option value=" & rcf_i & " selected>" & monthName(rcf_i, 1) & "</option>" & vbcr
    else
      rcf_out = rcf_out & "<option value=" & rcf_i & ">" & monthName(rcf_i, 1) & "</option>" & vbcr
    end if
  next 'rcf_i

  rcf_out = rcf_out & "</select><select name=""selectedDateStartYear"">"

  for rcf_i = rcf_firstYear to rcf_lastYear
    if cstr(""&selectedDateStartYear) = cstr(""&rcf_i) then
      rcf_out = rcf_out & "<option value=" & rcf_i & " selected>" & rcf_i & "</option>" & vbcr
    else
      rcf_out = rcf_out & "<option value=" & rcf_i & ">" & rcf_i & "</option>" & vbcr
    end if
  next 'rcf_i

  rcf_out = rcf_out & "</select></td>" & _
                      "<td><span class=""bodyText"">" & pageTextItemsValues(6) & "</span></td>" & _
                      "<td><select name=""selectedDateEndDay"">"

  for rcf_i = 1 to 31
    if cstr(""&selectedDateEndDay) = cstr(""&rcf_i) then
      rcf_out = rcf_out & "<option value=" & rcf_i & " selected>" & rcf_i & "</option>" & vbcr
    else
      rcf_out = rcf_out & "<option value=" & rcf_i & ">" & rcf_i & "</option>" & vbcr
    end if
  next 'rcf_i

  rcf_out = rcf_out & "</select><select name=""selectedDateEndMonth"">"

  for rcf_i = 1 to 12
    if cstr(""&selectedDateEndMonth) = cstr(""&rcf_i) then
      rcf_out = rcf_out & "<option value=" & rcf_i & " selected>" & monthName(rcf_i) & "</option>" & vbcr
    else
      rcf_out = rcf_out & "<option value=" & rcf_i & ">" & monthName(rcf_i) & "</option>" & vbcr
    end if
  next 'rcf_i

  rcf_out = rcf_out & "</select><select name=""selectedDateEndYear"">"

  for rcf_i = rcf_firstYear to rcf_lastYear
    if cstr(""&selectedDateEndYear) = cstr(""&rcf_i) then
      rcf_out = rcf_out & "<option value=" & rcf_i & " selected>" & rcf_i & "</option>" & vbcr
    else
      rcf_out = rcf_out & "<option value=" & rcf_i & ">" & rcf_i & "</option>" & vbcr
    end if
  next 'rcf_i

  rcf_out = rcf_out & "</select></td>" & _
                      "<td><input type=""submit"" name=""go"" value=""" & pageTextItemsValues(1) & """></td>" & _
                      "</tr></table>" & _
                      "<input type=""hidden"" name=""submitted"" value=""true""></form>" & _
                      "<br><br>"

  'return calendar form
  returncalendarForm = rcf_out

  'error recording
  recordError err.number, err.description, err.source
  
End Function



if contentError then

  ' An error occured and the content failed to be retrieved from the DB
  ' Display standby content.

  %><html>
  <head>
  <title>An error occurred</title>
  </head>
  <body bgcolor="#FFFFFF"><%

  SQLQuery = "SELECT defaultTitle FROM tblPrefs;"
  Set ds = objConn.execute(SQLQuery)

  if not ds.BOF AND not ds.EOF then

    send "<h3>" & ds("defaultTitle") & "</h3>"

  end if

  ds.close
  Set ds = nothing

  %>Sorry an error has occurred.
  </body>
  </html><%

end if

%><!-- #include file="inc/db_connection_close.asp" -->