<%

'=====================================================
' Globals
'=====================================================
'
' Debug mode
'   True 	- debug mode on, errors will halt script
'   False 	- debug mode off, script continues on error

Dim dMode
dMode = false


'=====================================================

response.buffer = true

if dMode <> true then
  on error resume next
else
  on error goto 0
end if

'=====================================================

'declare variables
Dim isSecurePage
Dim spwebsiteURL
Dim returnPage
Dim sessionPrefix
Dim g_i, g_s, g_j, g_pageName

' The content ID of the home page
Const g_homePageID = 1

'=====================================================

Sub loadSession()
  'loads session prefix
  if dMode <> true then on error resume next
  sessionPrefix = "aCMS"

  'error recording
  recordError err.number, err.description, err.source

End Sub

'=====================================================

Sub checkNoDb(cn_errNo)
  'checks if there has been an error connecting to the database
  'and directs to appropriate page
  if dMode <> true then on error resume next

  if cn_errNo <> 0 and isTextValid(request.queryString("nodb")) = false then
    'db broken -> go to no db redirect
    redirectBrowser cms_pageName & "?nodb=1"

  elseIf cn_errNo = 0 and isTextValid(request.queryString("nodb")) = true then
    'looks like db is ok but flag is set -> redirect back to main content
    redirectBrowser cms_pageName

  end if

End Sub

'=====================================================

Sub checkUseHTML(cu_contentID, cu_contentName, cu_languageName)
  'checks if html version of content should be used
  if dMode <> true then on error resume next

  'declare vars
  Dim cu_SQLQuery, cu_ds, cu_redirectHTML, cur_redirectURL

  'get flag from tblPrefs
  cu_SQLQuery = "SELECT useHTMLSite FROM tblPrefs;"
  Set cu_ds = objConn.Execute(cu_SQLQuery)

  if not cu_ds.EOF and not cu_ds.BOF then
    cu_redirectHTML = cBoolean(cu_ds("useHTMLSite"))
  else
    cu_redirectHTML = false
  end if
  cu_ds.Close
  Set cu_ds = Nothing

  if cu_redirectHTML = true then
    'get redirect url for current page
    cur_redirectURL = getFileName(cu_contentID, cu_contentName, cu_languageName)
    'redirect client
    if isTextValid(cur_redirectURL) = true then redirectBrowser(cur_redirectURL)
  end if

  'error recording
  recordError err.number, err.description, err.source

End Sub

'=====================================================

Function getFileName(gf_contentID, gf_contentName, gf_languageName)
  'returns html filename for input parameters
  if dMode <> true then on error resume next

  Dim gf_out

  'blank return if no contentID
  if isNumberValid(gf_contentID) = false then
    gf_out = ""
  else
    'ok -> build filename
    if gf_contentID = g_homePageID then
      gf_out = "c_default_" & Replace(gf_languageName," ","_") & ".htm"
    else
      gf_out = "c_" & CStr(Replace(gf_contentName & ""," ","_") & "_" & gf_contentID & "_" & Replace(gf_languageName," ","_") & ".htm")
    end if
  end if

  getFileName = gf_out

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function listSubContent(pID, rCount, ignoreSubContent)
  'returns sub content menu listing for input
  ' pID - parentID, rCount - depth of item
  if dMode <> true then on error resume next
  Dim lsc_ds, lsc_ds2, lsc_cID, lsc_temp

  SQLQuery = "SELECT tblContent_published.contentID, tblContent_published.contentLink, tblContent_published_languages.contentName FROM tblContent_published INNER JOIN tblContent_published_languages ON (tblContent_published.publishedContentID = tblContent_published_languages.publishedContentID AND tblContent_published_languages.languageID = " & session(sessionPrefix & "aCMS_languageID") & ") WHERE tblContent_published.contentOnline = " & prepBoolean("true") & " AND tblContent_published.contentVisibleMenu = " & prepBoolean("true") & " AND tblContent_published.parentID=" & pID & " ORDER BY tblContent_published.displayOrder;"
  Set lsc_ds = objConn.Execute(SQLQuery)

  if not lsc_ds.EOF and not lsc_ds.BOF then
    do until lsc_ds.EOF

      ' get menu code from application strings
      lsc_temp = application("aCMS_" & sessionPrefix & "_menuCode_" & rCount & "_" & templateID)
      ' No menu code setup - apply plain text link
      if not isTextValid(lsc_temp) then lsc_temp = "<a href=""[menuLink]"" class=""navLink"">[menuName]</a><br>"

      lsc_temp = replace(lsc_temp, "[menuName]", lsc_ds("contentName"), 1, -1, 1)

      if isTextValid(lsc_ds("contentLink")) then
        lsc_temp = replace(lsc_temp, "[menuLink]", lsc_ds("contentLink"), 1, -1, 1)
      else
        lsc_temp = replace(lsc_temp, "[menuLink]", cms_pageName & "?contentID=" & lsc_ds("contentID"), 1, -1, 1)
      end if

      listSubContent = listSubContent & lsc_temp

      if ignoreSubContent = false AND returnMenuMatch(lsc_ds("contentID"), rCount) then
        listSubContent = listSubContent & listSubContent(lsc_ds("contentID"), rCount+1, false)
      end if

      lsc_ds.MoveNext
    loop
  end if

  'close and destroy rs object
  lsc_ds.close
  Set lsc_ds = nothing

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function returnMenuMatch(db_cID, rC)
  'does this menu (rC) match the input cID
  if dMode <> true then on error resume next
  returnMenuMatch = false

  if application("aCMS_" & sessionPrefix & "_menuOpen") = true OR (db_cID = contentID AND hasSubContent(db_cID)) then
    returnMenuMatch = true
    exit function
  end if

  if countFields(c_parentIDs, ",") > rC then
    if (cInt(nthField(c_parentIDs, ",", rC))) = db_cID then
      returnMenuMatch = true
      exit function
    end if
  end if

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function hasSubContent(cID)
  'does the input contentID have children
  if dMode <> true then on error resume next

  SQLQuery = "SELECT contentID FROM tblContent WHERE tblContent.parentID=" & cID & ";"
  Set ds2 = objConn.execute(SQLQuery)
  if not ds2.BOF AND not ds2.EOF then
    hasSubContent = true
  else
    hasSubContent = false
  end if
  ds2.close
  Set ds2 = nothing

  'error recording
  recordError err.number, err.description, err.source

End function

'=====================================================

Function indentCategory(depth)
  'returns indent string to depth input
  if dMode <> true then on error resume next

  'declare vars
  Dim ci_s, ci_s2, ci_i

  for ci_i = 1 to depth-1
    indentCategory = indentCategory & "-"
  next 'i

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Sub setupCmsUser(existingUser)
  'This sub creates the required session variables for a new user
  if dMode <> true then on error resume next

  'declare vars
  Dim sc_i, sc_j

  loadlanguageID()

  setupMenus()

  if existingUser = false then

    session(sessionPrefix & "aCMSsessionID") = Session.sessionID & "_" & year(date()) & minDigits(month(date()), 2) & minDigits(day(date()), 2) & "_" & minDigits(hour(now()), 2) & minDigits(minute(now()), 2) & minDigits(second(now()), 2) & "_"
    for sc_i = 1 to 10
      randomize
      sc_j = int(((35-1) * rnd) + 1)
      if sc_j > 26 then
        session(sessionPrefix & "aCMSsessionID") = session(sessionPrefix & "aCMSsessionID") & sc_j-26
      else
        session(sessionPrefix & "aCMSsessionID") = session(sessionPrefix & "aCMSsessionID") & chr(sc_j+64)
      end if
    next 'sc_i
    session(sessionPrefix & "searchCount") = 0
    session(sessionPrefix & "referrer") = request.serverVariables("HTTP_REFERER")

    ' ensure not search engine before logging visitor
    if isSearchEngine() = false then
      ' Log user info to DB
      SQLQuery = "INSERT INTO tblVisitors (sessionID, visitorIP, visitorBrowser, visitorDateTime, referrer, entryPage, languageID) VALUES ('" & session(sessionPrefix & "aCMSsessionID") & "','" & request.servervariables("REMOTE_ADDR") & "','" & prepString(left(request.serverVariables("HTTP_USER_AGENT"), 100)) & "'," & prepDate(now()) & ",'" & prepString(left(session(sessionPrefix & "referrer"), 255)) & "','" & prepString(left(request.serverVariables("SCRIPT_NAME"), 100)) & "', " & session(sessionPrefix & "aCMS_languageID") & ");"
      objConn.Execute SQLQuery

      ' Update stats
      SQLQuery = "SELECT statisticID FROM tblStatistics WHERE (((Year(statDate))=" & year(date()) & ") AND ((Month(statDate))=" & month(date()) & ") AND ((day(statDate))=" & day(date()) & "));"
      Set ds = objConn.execute(SQLQuery)
      if ds.BOF OR ds.EOF then
        SQLQuery = "INSERT INTO tblStatistics (statDate, visitors, hour0, hour1, hour2, hour3, hour4, hour5, hour6, hour7, hour8, hour9, hour10, hour11, hour12, hour13, hour14, hour15, hour16, hour18, hour19, hour20, hour21, hour22, hour23) VALUES (" & prepDate(date() & " 12:00:00") & ","
        for sc_i = 0 to 23
          if sc_i = hour(now()) then
            SQLQuery = SQLQuery & "1, "
          else
            SQLQuery = SQLQuery & "0, "
          end if
        next
        ' remove last comma & space
        SQLQuery = left(SQLQuery, len(SQLQuery)-2) & ");"
        objConn.execute(SQLQuery)
      else
        ' stats record found - update
        SQLQuery = "UPDATE tblStatistics SET visitors=visitors+1, hour" & hour(now()) & "=hour" & hour(now()) & "+1 WHERE (((year(statDate))=" & year(date()) & ") AND ((month(statDate))=" & month(date()) & ") AND ((day(statDate))=" & day(date()) & "));"
        objConn.execute(SQLQuery)
      end if
      ds.close
      Set ds = nothing
    end if

  end if

  'error recording
  recordError err.number, err.description, err.source

End Sub

'=====================================================

Function lookUpItem(tableName, returnfieldName, fieldName, fieldValue)
  on error resume next
  Dim lui_s, lui_SQLQuery, lui_ds
  lui_s = ""

  if isTextValid(fieldName) AND isTextValid(fieldValue) then
  if isNumeric(fieldValue) then
    lui_SQLQuery = "SELECT " & returnfieldName & " FROM " & tableName & " WHERE " & fieldName & "=" & fieldValue & ";"
  else
    lui_SQLQuery = "SELECT " & returnfieldName & " FROM " & tableName & " WHERE " & fieldName & "='" & fieldValue & "';"
  end if
  else
    lui_SQLQuery = "SELECT " & returnfieldName & " FROM " & tableName & ";"
  end if
  Set lui_ds = objConn.Execute(lui_SQLQuery)

  if err <> 0 AND isTextValid(fieldName) AND isTextValid(fieldValue) then
    if err.number = -2147217913 then
      if isNumeric(fieldValue) then
        lui_SQLQuery = "SELECT " & returnfieldName & " FROM " & tableName & " WHERE " & fieldName & "='" & fieldValue & "';"
      else
        lui_SQLQuery = "SELECT " & returnfieldName & " FROM " & tableName & " WHERE " & fieldName & "=" & fieldValue & ";"
      end if
      Set lui_ds = objConn.Execute(lui_SQLQuery)
    end if
  end if
  If not lui_ds.eof and not lui_ds.bof then
    lui_s = lui_ds(returnfieldName)
  end if
  lui_ds.close
  set lui_ds = nothing

  lookUpItem = lui_s

  if dMode = true then on error goto 0

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function getContentparentIDs(cID)
  'retrieves content parent ID's for input contentID
  if dMode <> true then on error resume next

  if not isNumberValid((cID)) then exit function

  Dim gpi_ds, fSQLQuery
  Dim searchCID, searchName
  Dim searchComplete
  Dim parentIDs
  Dim gpids_i

  searchComplete = false
  searchCID = cID
  parentIDS = cID & ","
  c_ParentNames = ""

  Do until searchComplete = True
    fSQLQuery = "SELECT parentID, contentName FROM tblContent INNER JOIN tblContent_languages ON tblContent.contentID = tblContent_languages.contentID WHERE tblContent.contentID = " & searchCID & ";"
    Set gpi_ds = objConn.Execute(fSQLQuery)
    if not gpi_ds.EOF and not gpi_ds.BOF then
      searchCID = gpi_ds("parentID")
      searchName = gpi_ds("contentName")
    end if
    c_ParentNames = c_ParentNames & searchName & "|*&|"

    if searchCID = 0 then
      searchComplete = true
    else
      parentIDs = parentIDs & searchCID & ","
    end if
    gpi_ds.close
  Loop

  Set gpi_ds = nothing
  if isTextValid(parentIDs) then
    parentIDs = left(parentIDs, len(parentIDs)-1)
    c_ParentNames = left(c_ParentNames, len(c_ParentNames)-4)
  end if


  getContentparentIDs = parentIDs
  if countFields(getContentparentIDs, ",") > 1 then
    parentIDs = ""
    searchName = ""
    for gpids_i = countFields(getContentparentIDs, ",") to 1 step -1
      parentIDs = parentIDs & nthField(getContentparentIDs, ",", gpids_i) & ","
      searchName = searchName & nthField(c_parentNames, "|*&|", gpids_i) & "|*&|"
    next 'gpids_i
    parentIDs = left(parentIDs, len(parentIDs)-1)
    getContentparentIDs = parentIDs
    c_ParentNames = left(searchName, len(searchName)-4)
  end if

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function getChildIDs(gc_tableName, gc_idName, gc_parentName, gc_cID)
  'obtains comma delimited list of all distinct child ids from db

  'error handling
  if dMode <> true then on error resume next

  'declare vars
  Dim gci_ds, gci_SQLQuery
  Dim gci_out

  'get children for current parent
  gci_SQLQuery = "SELECT " & gc_idName & " FROM " & gc_tableName & " WHERE " & gc_parentName & " = " & gc_cID & ";"
  Set gci_ds = objConn.Execute(gci_SQLQuery)

  'records found?
  if not gci_ds.EOF and not gci_ds.BOF then

    'yes -> loop thru
    do until gci_ds.EOF

      if isTextValid(gci_out) = true then gci_out = gci_out & ","

      gci_out = gci_out & gci_ds("topicID")
      gci_out = gci_out & getChildIDs(gc_tableName, gc_idName, gc_parentName, gci_ds("topicID"))

      gci_ds.MoveNext
    loop

  end if

  gci_ds.Close
  Set gci_ds = Nothing

  getChildIDs = gci_out

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function cBoolean(data)
  if dMode <> true then on error resume next

  if databaseType = 3 then
    'mySQL specific code

    if lCase(CStr(""&data)) = "true" OR CStr(""&data) = "1" then
      cBoolean = true
    else
      cBoolean = false
    end if

  else

    if lCase(data) = "true" OR data = "1" OR data = true then
      cBoolean = true
    else
      cBoolean = false
    end if
  end if

  'error recording
  recordError err.number, err.description, err.source

end Function

'=====================================================

Function cYesNo(data)
  if dMode <> true then on error resume next
  if vartype(data) = 16 then
    if data = "1" then
      cYesNo = "Yes"
    else
      cYesNo = "No"
    end if
  else
    if lCase(data) = "true" OR data = "1" OR data = true then
      cYesNo = "Yes"
    else
      cYesNo = "No"
    end if
  end if

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function est(esStr)
  if dMode <> true then on error resume next
  Dim es_x, es_i, es_tmp
  For es_i = 1 To Len(esStr)
    es_x = mid(esStr, es_i, 1)
    es_tmp = es_tmp & Chr(Asc(es_x)+1)
  Next
  es_tmp = StrReverse(es_tmp)
  est = es_tmp

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function dst(dsStr)
  if dMode <> true then on error resume next
  Dim ds_x, ds_i, ds_tmp
  dsStr = StrReverse(dsStr)
  For ds_i = 1 To Len(dsStr)
    ds_x = mid(dsStr, ds_i, 1)
    ds_tmp = ds_tmp & Chr(Asc(ds_x)-1)
  Next
  dst = ds_tmp

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function countFields(source, separator)
  if dMode <> true then on error resume next
  Dim cfStartPos, cfCount, cfTemp
  cfStartPos = 1
  cfCount = 1
  if isTextValid(source) then
    do
      cfTemp = inStr(cfStartPos, source, separator)
      if cfTemp > 0 then cfCount = cfCount + 1
      cfStartPos = cfTemp + 1
    loop until inStr(cfStartPos, source, separator) = 0
  else
    cfCount = 0
  end if
  countFields = cfCount

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function nthField(source, separator, fieldNumber)
  if dMode <> true then on error resume next
  Dim nf_array, nf_fn
  nf_fn = fieldNumber - 1
  if source = "" OR nf_fn < 0 then
    nthField = ""
  else
    nf_array = split(source, separator)
    if nf_fn <= uBound(nf_array) then
      nthField = nf_array(nf_fn)
    else
      nthField = ""
    end if
  end if

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function minDigits(sInput, noDigits)
  if dMode <> true then on error resume next
  Dim md_output, md_j
  md_output = sInput
  if len(sInput) < noDigits then
    for md_j = 1 to (noDigits-len(sInput))
      md_output = "0" & md_output
    next 'md_j
  end if
  minDigits = md_output

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function lookupPageName()
  if dMode <> true then on error resume next
  if isTextValid(g_pageName) then
    lookupPageName = g_pageName
  else
    Dim lpn_sn

    lpn_sn = request.serverVariables("SCRIPT_NAME")
    lookupPageName = mid(lpn_sn, inStrRev(lpn_sn, "/") + 1)
    g_pageName = lookupPageName
  end if

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function seek(startPos, sInput, searchChar)
  if dMode <> true then on error resume next
  Dim s_i
  Dim s_success

  s_i = startPos
  s_success = false

  if inStr(sInput, searchChar) = 0 then
    seek = 0
    exit function
  end if

  do
    if mid(sInput, s_i, 1) = searchChar then
      seek = s_i
      exit function
    end if
    s_i = s_i - 1
    if s_i < 0 then
      seek = 0
      exit function
    end if
  loop until s_success = true

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function isTextValid(str)
  if dMode <> true then on error resume next
  if trim(str) = "" or isNull(str) or isEmpty(str) then
    isTextValid = false
  else
    isTextValid = true
  end if

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function isNumberValid(str)

  if dMode <> true then on error resume next
  if cStr(""&str) = "" or isNull(str) or isEmpty(str) OR not isNumeric(cStr(""&str)) then
    isNumberValid = false
  else
    isNumberValid = true
  end if

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function lstr(ls_one, ls_two)
  'string comparison trim/lcase/cstr
  if dMode <> true then on error resume next
  if lcase(trim(cstr(""&ls_one))) = lcase(trim(cstr(""&ls_two))) then
    lstr = true
  else
    lstr = false
  end if

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function formatCurr(amount, noDigits)
  if dMode <> true then on error resume next
  Dim fc_i, fc_j
  fc_j = countFields(session(sessionPrefix & "formatCurrReplace"), "**")
  if not isNumeric(amount) then exit function
  if fc_j > 0 then
    formatCurr = formatCurrency(amount, noDigits)
    for fc_i = 1 to fc_j
      formatCurr = replace(formatCurr, nthField(session(sessionPrefix & "formatCurrReplace"), "**", fc_i), "")
    next
  else
    formatCurr = formatCurrency(amount, noDigits)
  end if
  if Trim(session(sessionPrefix & "currencySuffix")) <> "" then formatCurr = formatCurr & " " & session(sessionPrefix & "currencySuffix")

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function minDigits2(sInput, noDigits)
  if dMode <> true then on error resume next
  Dim sOutput2, md_i
  sOutput2 = sInput
  if len(sInput) < noDigits then
    for md_i = 1 to (noDigits-len(sInput))
      sOutput2 = sOutput2 & " "
    next 'md_i
  end if
  minDigits2 = sOutput2

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function maxLength(sInput, noChars)
  'trims input at noChars for shortened ... text display
  if dMode <> true then on error resume next
  Dim mloutput, mlLength
  if len(sInput) > noChars then
    mlLength = inStr(noChars, sInput, " ")
    if mlLength=0 then mlLength = noChars+1
    if mlLength <> 0 then
      mloutput = left(sInput, mlLength-1) & "..."
    else
      mloutput = sInput
    end if
  else
    mloutput = sInput
  end if
  maxLength = mloutput

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function prepDate(theDate)
  if dMode <> true then on error resume next

  prepDate = year(theDate) & "-" & minDigits(month(theDate), 2) & "-" & minDigits(day(theDate), 2) & " " & minDigits(hour(theDate), 2) & ":" & minDigits(minute(theDate), 2) & ":" & minDigits(second(theDate), 2)
  if databaseType = 1 then
    prepDate = "#" & prepDate & "#"
  elseIf databaseType = 2 OR databaseType = 3 then
    prepDate = "{ts '" & prepDate & "'}"
  end if

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function prepCurrency(theAmount)
  if dMode <> true then on error resume next
  Dim pcChar, resultPc
  theAmount = trim(theAmount)
  resultPc = theAmount

  if not isNumberValid(resultPc) then
    prepCurrency = 0
    exit function
  end if

  for pcChar = 1 to Len(theAmount)
    if not isNumeric(mid(theAmount,pcChar,1)) and not mid(theAmount,pcChar,1) = "." and not mid(theAmount,pcChar,1) = "," and not ( (pcChar = 1) and (mid(theAmount,pcChar,1) = "-") ) then
      resultPc = Replace(resultPc, mid(theAmount,pcChar,1),"")
    end if
  next
  prepCurrency = resultPc

  if not isNormalCurrency(session(sessionPrefix & "LCID")) then
    ''fix for comma instead of decimal format currencies
    prepCurrency = replace(prepCurrency, ".", "")
    prepCurrency = replace(prepCurrency, ",", ".")
  else
    prepCurrency = formatNumber(prepCurrency,2)
    prepCurrency = replace(prepCurrency, ".", "")
    prepCurrency = replace(prepCurrency, ",", "")

    prepCurrency = left(prepCurrency, len(prepCurrency)-2) & "." & right(prepCurrency, 2)
  end if

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function prepNumber(theamount, decimalPlaces)
  if dMode <> true then on error resume next
  if isNumberValid(theAmount) then
    prepNumber = formatNumber(theamount, decimalPlaces)
  else
    prepNumber = formatNumber(0, decimalPlaces)
  end if
  prepNumber = formatNumber(theamount, decimalPlaces)
  prepNumber = replace(prepNumber, ",", "")
  prepNumber = replace(prepNumber, ".", "")
  prepNumber = replace(prepNumber, "'", "")
  prepNumber = replace(prepNumber, " ", "")
  prepNumber = replace(prepNumber, "$", "")
  if decimalPlaces > 0 then
    prepNumber = left(prepNumber, len(prepNumber)-decimalPlaces) & "." & right(prepNumber, decimalPlaces)
  else
    prepNumber = left(prepNumber, len(prepNumber)-decimalPlaces)
  end if

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function prepBoolean(theValue)
  if dMode <> true then on error resume next
  if databaseType = 1 then
    if lCase(theValue) = "true" OR theValue = true then
      prepBoolean = "True"
    else
      prepBoolean = "False"
    end if
  elseIf databaseType = 2 OR databaseType = 3 then
    if lCase(theValue) = "true" OR theValue = true then
      prepBoolean = 1
    else
      prepBoolean = 0
    end if
  end if

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function prepString(theValue)
  if dMode <> true then on error resume next
  if not isNull(theValue) then
    prepString = replace(theValue, "'", "''")
  else
    prepString = ""
  end if

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function getwebsiteURL()
  'returns website url

  'error handling
  if dMode <> true then on error resume next

  Dim gwObjConn, gwDs, gwSQLQuery
  gwSQLQuery = "SELECT websiteURL FROM tblPrefs;"
  Set gwDs = objConn.Execute(gwSQLQuery)
  if not gwDs.EOF and not gwDs.BOF then
    getwebsiteURL = gwDs("websiteURL")
  end if
  gwds.close
  Set gwDs = Nothing

  'ensure we have a forward slash on the end in case user has entered without
  if isTextValid(getwebsiteURL) AND not Right(getwebsiteURL, 1) = "/" then getwebsiteURL = getwebsiteURL & "/"

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Sub setupSecurePage(ssl_pageName, myAcc)
  'sets up page called from to use ssl if possible
  if dMode <> true then on error resume next

  Dim is_ds, is_SQLQuery, is_enableSSL, is_sslDomain, is_websiteURL, is_queryString

  is_SQLQuery = "SELECT enableSSL, myAccountSSL, sslDomain, websiteURL FROM tblPrefs;"
  Set is_ds = objConn.Execute(is_SQLQuery)

  'was a record found?
  if not is_ds.EOF and not is_ds.BOF then
    'details retrieved
    is_enableSSL = CBoolean(is_ds("enableSSL"))
    is_sslDomain = is_ds("sslDomain")
    is_websiteURL = is_ds("websiteURL")

    ' my Account test
    if myAcc = true AND CBoolean(is_ds("myAccountSSL")) = false then
      if lCase(request.serverVariables("HTTPS")) = "on" then
        'should not be ssl -> redirect back
        is_ds.Close
        Set is_ds = Nothing

        if isTextValid(request.serverVariables("QUERY_STRING")) then
          g_s = g_s & "?" & request.serverVariables("QUERY_STRING") & "&esi=" & session(sessionPrefix & "aCMSsessionID") & "&csir=1&lang=" & session(sessionPrefix & "aCMS_languageID")
        else
          g_s = g_s & "?esi=" & session(sessionPrefix & "aCMSsessionID") & "&csir=1&lang=" & session(sessionPrefix & "aCMS_languageID")
        end if
        if isTextValid(is_websiteURL) then g_s = is_websiteURL & g_s
        if inStr(lCase(g_s), "http://") > 0 then redirectBrowser g_s

      end if
      exit sub
    end if

    'is ssl turned on?
    if is_enableSSL = true OR myAcc = true then
      'yes, setup variables
      isSecurePage = true
      spwebsiteURL = getwebsiteURL()
    end if
  end if
  'close and destroy rs object
  is_ds.close
  Set is_ds = Nothing

  'is ssl not on?
  if lCase(request.serverVariables("HTTPS")) <> "on" then

    if is_enableSSL = true OR myAcc = true then
      if isTextValid(ssl_pageName) then

        'redirectBrowser is_sslDomain & ssl_pageName

      else
        is_queryString = request.serverVariables("QUERY_STRING")
        if isTextValid(is_queryString) = true then is_queryString = "&" & is_queryString

        redirectBrowser is_sslDomain & lookupPageName() & "?esi=" & session(sessionPrefix & "aCMSsessionID") & "&csir=1&lang=" & session(sessionPrefix & "aCMS_languageID") & is_queryString
      end if
    end if
  end if

  'error recording
  recordError err.number, err.description, err.source

End Sub

'=====================================================

Sub noCache(nc_type)
  'inits anti-cache response
  '
  ' nc_type = 1 - ASP
  ' nc_type = 2 - HTML

  if dMode <> true then on error resume next

  if nc_type = 1 then

    Response.Expires = 60
    Response.Expiresabsolute=Now()-2
    Response.AddHeader "pragma","no-cache"
    Response.AddHeader "cache-control","private"
    Response.CacheControl = "no-cache"

  elseIf nc_type = 2 then

    %><meta http-equiv="Expires" CONTENT="0"><%=vbCr%><meta http-equiv="Cache-Control" CONTENT="no-cache"><%=vbCr%><meta http-equiv="Pragma" CONTENT="no-cache"><%=vbCr%><%

  end if

  'error recording
  recordError err.number, err.description, err.source

End Sub

'=====================================================

Function checkEmailAddress(ea)
  'validates email address

  if dMode <> true then on error resume next

  Dim dotFound, atFound, checkOk, ch, stopPos
  Dim cea_i, cea_j

  dotFound = false
  atFound = false

  checkOk = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.@_-&"

  '// loop thru string
  for cea_i = 0 to (Len(ea)-1)
    '// get current char
    ch = mid(CStr(ea), cea_i+1, 1)

    if CStr(ch) = "@" then
      if cea_i = 0 or cea_i = (Len(ea)-1) then
        checkEmailAddress = false
        exit function
      else
        atFound = cea_i
      end if
    end if
    if CStr(ch) = "." then
      if cea_i = 0 or cea_i = (Len(ea)-1) then
        checkEmailAddress = false
        exit function
      else
        dotFound = cea_i
      end if
    end if

    '// loop thru checkOk to ensure valid
    for cea_j = 0 to (Len(checkOk)-1)
      stopPos = Len(checkOk)
      if CStr(mid(CStr(checkOk), cea_j+1, 1)) = CStr(ch) then
        stopPos = cea_j
        exit for
      end if
    next
    if cLng(stopPos) = Len(checkOk) then
      '// the char was not found
      checkEmailAddress = false
      exit function
    end if
  next
  '// now check that there are characters between the @ and the .
  if (cLng(dotFound)-cLng(atFound)) = 1 or dotFound = false or atFound = false then
    checkEmailAddress = false
    exit function
  end if
  checkEmailAddress = true

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function convertDate(theDay, theMonth, theYear)
  'converts input into usable standard date string YYYY-MM-DD

  if dMode <> true then on error resume next
  convertDate = theYear & "-" & minDigits(theMonth, 2) & "-" & minDigits(theDay, 2)

  'error recording
  recordError err.number, err.description, err.source

end Function

'=====================================================

Sub recordError(re_errno, re_errdesc, re_errsource)
  if dMode <> true then on error resume next

  'fills global error strings with errors for parsing and
  'db insertion in db_connection_close.asp

  'check if error has been passed across
  if re_errno <> 0 then
    'is an error already present in strings?
    if error_number_string <> "" then
      'add delimiter and new error details
      error_number_string 	= error_number_string & "|~|" & re_errno
      error_desc_string		= error_desc_string & "|~|" & re_errdesc
      error_source_string	= error_source_string & "|~|" & re_errsource
    else
      'no errors present...set directly
      error_number_string 	= re_errno
      error_desc_string		= re_errdesc
      error_source_string	= re_errsource
    end if
  end if

  'clear error object
  err.clear

End Sub

'=====================================================

Sub reportError(errNo, errDesc, errSource, errPage)
  'inserts passed details into tblErrors

  if dMode <> true then on error resume next

  Dim re_SQLQuery

  re_SQLQuery = "INSERT INTO tblErrors (errorDateTime, errorNumber, errorDescription, errorSource, errorPage, errorviewed) VALUES (" & prepDate(now()) & ", " & errNo & ", '" & prepString(errDesc) & "', '" & prepString(errSource) & "', '" & prepString(left(errPage,100)) & "', " & prepBoolean("false") & ");"
  objConn.Execute re_SQLQuery

end sub

'=====================================================

Function generateRandomString(grs_no_chars)
  'generates random numeric string
  if dMode <> true then on error resume next

  Dim grs_useAlpha
  grs_useAlpha = false

  'generate random string to length specified by grs_no_chars
  do until len(generateRandomString) >= grs_no_chars
    randomize
    if grs_useAlpha = true then
      'get alpha
      generateRandomString = generateRandomString & getAlpha(fix(rnd * 27))
    else
      generateRandomString = generateRandomString & fix(rnd * 10)
    end if

    grs_useAlpha = not grs_useAlpha
  loop

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function getAlpha(ga_number)
  'returns alpha character that corresponds to input number

  if dMode <> true then on error resume next

  'returns alphabetical character relating to number passed in (1 - 26)
  Select Case Cstr(""&ga_number)
    Case "1"
      getAlpha = "a"
    Case "2"
      getAlpha = "b"
    Case "3"
      getAlpha = "c"
    Case "4"
      getAlpha = "d"
    Case "5"
      getAlpha = "e"
    Case "6"
      getAlpha = "f"
    Case "7"
      getAlpha = "g"
    Case "8"
      getAlpha = "h"
    Case "9"
      getAlpha = "i"
    Case "10"
      getAlpha = "j"
    Case "11"
      getAlpha = "k"
    Case "12"
      getAlpha = "l"
    Case "13"
      getAlpha = "m"
    Case "14"
      getAlpha = "n"
    Case "15"
      getAlpha = "o"
    Case "16"
      getAlpha = "p"
    Case "17"
      getAlpha = "q"
    Case "18"
      getAlpha = "r"
    Case "19"
      getAlpha = "s"
    Case "20"
      getAlpha = "t"
    Case "21"
      getAlpha = "u"
    Case "22"
      getAlpha = "v"
    Case "23"
      getAlpha = "w"
    Case "24"
      getAlpha = "x"
    Case "25"
      getAlpha = "y"
    Case "26"
      getAlpha = "z"
    Case Else
      getAlpha = "a"
  End Select

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function executeInsert(ei_SQLQuery)
  'executes insert query passed, and returns record identity
  if dMode <> true then on error resume next

  Dim ei_ds, ei_out, ei_tableName

  if databaseType = 1 then
    objConn.Execute ei_SQLQuery
    Set ei_ds = objConn.execute("SELECT @@IDENTITY")
    if not ei_ds.EOF and not ei_ds.BOF then ei_out = cInt(ei_ds(0))
    ei_ds.close
    Set ei_ds = nothing
  elseIf databaseType = 2 then
    ei_SQLQuery = ei_SQLQuery & "SELECT @@IDENTITY AS IDofRecord;"
    Set ei_ds = objConn.Execute(ei_SQLQuery).NextRecordSet
    if not ei_ds.EOF and not ei_ds.BOF then ei_out = cInt(ei_ds("IDofRecord"))
    ei_ds.close
    Set ei_ds = nothing
  elseIf databaseType = 3 then
    ei_tableName = returnTableName(ei_SQLQuery)
    if isTextValid(ei_tableName) = true then
      objConn.Execute(ei_SQLQuery)
      Set ei_ds = objConn.Execute("SELECT LAST_INSERT_ID() AS IDofRecord FROM " & ei_tableName & ";")
      if not ei_ds.BOF AND not ei_ds.EOF then ei_out = cInt(ei_ds("IDofRecord"))
      ei_ds.close
      Set ei_ds = nothing
    else
      send3 "aCMS Engine: Table name not returned. Unable to execute query."
      reportError 0, "aCMS Engine: Table name not returned. Unable to execute query.", "admin_functions.asp - executeInsert()", lookupPageName()
    end if
  end if

  executeInsert = ei_out

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function returnTableName(rtn_SQLQuery)
  'splits query, loops through and extracts table name
  if dMode <> true then on error resume next

  Dim rtn_split, rtn_i, rtn_out

  'split string
  rtn_split = split(rtn_SQLQuery," ")
  'loop
  for rtn_i = 1 to ubound(rtn_split)
    'does the string contain tbl prefix
    if InStr(LCase(rtn_split(rtn_i)),"tbl") then
      'set output val
      rtn_out = rtn_split(rtn_i)

      exit for
    end if
  next
  if isTextValid(rtn_out) = false then
    send3 "aCMS mySQL Engine: Badly formatted SQL string, unable to extract table name."
    reportError 0, "aCMS mySQL Engine: Badly formatted SQL string, unable to extract table name.", "globals_functions.asp - returnTableName()", lookupPageName()
  end if

  'set output value
  returnTableName = rtn_out

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Sub redirectBrowser(URL)
  'closes and destroys potentially open db objects and redirects client browser
  'to input url

  if dMode <> true then on error resume next
  if not isTextValid(URL) then exit sub
  Dim rb_ss:rb_ss = request.serverVariables("SERVER_SOFTWARE")
  if lCase(typeName(ds)) = "recordset" then
    on error resume next
    ds.close
    Set ds = nothing
    if dMode = true then on error goto 0
  end if
  if lCase(typeName(ds2)) = "recordset" then
    on error resume next
    ds2.close
    Set ds2 = nothing
    if dMode = true then on error goto 0
  end if

  'error recording
  recordError err.number, err.description, err.source

  if lCase(typeName(objConn)) = "connection" then
    objConn.close
    Set objConn = nothing
  end if
  response.redirect URL

End Sub

'=====================================================

Sub setupMenus()
  'sets up menus for content in application object

  if dMode <> true then on error resume next

  Dim sm_mcCount, sm_reload, sm_menuOpen, sm_mcArray(), sm_i

  ' count maximum number of sub menu code is in db
  SQLQuery = "SELECT Count(tblMenuCode.menuCodeID) AS mcCount, tblPrefs.menuOpen, tblPrefs.menuReload FROM tblMenuCode, tblPrefs GROUP BY tblPrefs.menuReload, tblPrefs.menuOpen;"
  Set ds = objConn.execute(SQLQuery)
  if not ds.BOF AND not ds.EOF then
    sm_mcCount = ds("mcCount")
    sm_reload = cBoolean(ds("menuReload"))
    sm_menuOpen = cBoolean(ds("menuOpen"))
  else
    sm_mcCount = 0
  end if
  ds.close

  if not isNumberValid(sm_mcCount) OR (sm_mcCount <> application("aCMS_" & sessionPrefix & "_menuMaxLevel")) OR sm_reload = true then

    if sm_reload = true then
      SQLQuery = "UPDATE tblPrefs SET menuReload=" & prepBoolean("False") & ";"
      objConn.execute(SQLQuery)
    end if
    application("aCMS_" & sessionPrefix & "_menuMaxLevel") = sm_mcCount
    application("aCMS_" & sessionPrefix & "_menuOpen") = sm_menuOpen

    if sm_mcCount > 0 then
      SQLQuery = "SELECT tblMenuCode.menuCode, tblMenuCode_templateIDs.templateID, tblMenuCode.menuCodeDepth FROM tblMenuCode INNER JOIN tblMenuCode_templateIDs ON tblMenuCode.menuCodeID = tblMenuCode_templateIDs.menuCodeID ORDER BY tblMenuCode.menuCodeDepth;"
      Set ds = objConn.execute(SQLQuery)
      if not ds.BOF AND not ds.EOF then
        'ReDim sm_mcArray(sm_mcCount + 1)
        'sm_i = 1
        do until ds.EOF
          application("aCMS_" & sessionPrefix & "_menuCode_" & ds("menuCodeDepth") & "_" & ds("templateID")) = ds("menuCode")

          ds.moveNext
        loop

      end if
      ds.close

    end if
  end if

  Set ds = nothing

  'error recording
  recordError err.number, err.description, err.source

end sub

'=====================================================

Sub loadLanguageCoding()
  'load language coding for current languageID
  if dMode <> true then on error resume next

  'declare vars
  Dim llc_ds, llc_SQLQuery

  'build and execute sql to get rs of language details
  llc_SQLQuery = "SELECT charSet, codePage, languageName, languageImage FROM tblLanguages WHERE languageOnline=" & prepBoolean("True") & " AND languageID=" & session(sessionPrefix & "aCMS_languageID") & ";"
  Set llc_ds = objConn.Execute(llc_SQLQuery)

  if not llc_ds.EOF and not llc_ds.BOF then
    session(sessionPrefix & "aCMS_languageName") = llc_ds("languageName")
    session(sessionPrefix & "aCMS_languageImage") = llc_ds("languageImage")
    session(sessionPrefix & "aCMS_charSet") = llc_ds("charSet")
    session(sessionPrefix & "aCMS_codePage") = llc_ds("codePage")
  else
    session(sessionPrefix & "aCMS_charSet") = "ISO-8859-1"
    session(sessionPrefix & "aCMS_codePage") = "1252"
    session(sessionPrefix & "aCMS_languageName") = ""
    session(sessionPrefix & "aCMS_languageImage") = ""
  end if

  'close and destroy rs object
  llc_ds.Close
  Set llc_ds = nothing

  'error recording
  recordError err.number, err.description, err.source

End Sub

'=====================================================

Sub loadLanguageCodingTimeout(llct_langID)
  'loads response charSet and code page for timeout page

  'error handling
  if dMode <> true then on error resume next

  Dim llct_ds

  SQLQuery = "SELECT charSet, codePage FROM tblLanguages WHERE languageOnline=" & prepBoolean("True") & " AND languageID=" & llct_langID & ";"
  Set llct_ds = objConn.Execute(SQLQuery)
  if not llct_ds.EOF and not llct_ds.BOF then
    response.charSet = llct_ds("charSet")
    Session.codePage = llct_ds("codePage")
  else
    response.charSet = "ISO-8859-1"
    Session.codePage = "1252"
  end if
  llct_ds.Close
  Set llct_ds = nothing

  'error recording
  recordError err.number, err.description, err.source

End Sub

'=====================================================

Sub loadlanguageID()
  'loads languageID as appropriate

  if dMode <> true then on error resume next
  Dim lli_ds

  SQLQuery = "SELECT languageID, charSet, codePage, languageName, languageImage FROM tblLanguages WHERE languageOnline=" & prepBoolean("True") & " AND languageDefault=" & prepBoolean("true") & ";"
  Set lli_ds = objConn.Execute(SQLQuery)
  if not lli_ds.EOF and not lli_ds.BOF then
    session(sessionPrefix & "aCMS_languageID") = lli_ds("languageID")
    session(sessionPrefix & "aCMS_charSet") = lli_ds("charSet")
    session(sessionPrefix & "aCMS_codePage") = lli_ds("codePage")
    session(sessionPrefix & "aCMS_languageName") = lli_ds("languageName")
    session(sessionPrefix & "aCMS_languageImage") = lli_ds("languageImage")
  end if
  lli_ds.Close

  if isNumberValid(session(sessionPrefix & "aCMS_languageID")) = false then
    'no default language -> set min record
    SQLQuery = "SELECT languageID, charSet, codePage, languageName, languageImage FROM tblLanguages WHERE languageOnline=" & prepBoolean("True") & " ORDER BY languageID ASC;"
    Set lli_ds = objConn.Execute(SQLQuery)
    if not lli_ds.EOF and not lli_ds.BOF then
      session(sessionPrefix & "aCMS_languageID") = lli_ds("languageID")
      session(sessionPrefix & "aCMS_charSet") = lli_ds("charSet")
      session(sessionPrefix & "aCMS_codePage") = lli_ds("codePage")
      session(sessionPrefix & "aCMS_languageName") = lli_ds("languageName")
    session(sessionPrefix & "aCMS_languageImage") = lli_ds("languageImage")
    end if
    lli_ds.Close
    if isNumberValid(session(sessionPrefix & "aCMS_languageID")) = false then
      SQLQuery = "SELECT languageID, charSet, codePage, languageName, languageImage FROM tblLanguages ORDER BY languageID ASC;"
      Set lli_ds = objConn.Execute(SQLQuery)
      if not lli_ds.EOF and not lli_ds.BOF then
        session(sessionPrefix & "aCMS_languageID") = lli_ds("languageID")
        session(sessionPrefix & "aCMS_charSet") = lli_ds("charSet")
        session(sessionPrefix & "aCMS_codePage") = lli_ds("codePage")
        session(sessionPrefix & "aCMS_languageName") = lli_ds("languageName")
        session(sessionPrefix & "aCMS_languageImage") = lli_ds("languageImage")
      end if
      lli_ds.Close
    end if
    if isNumberValid(session(sessionPrefix & "aCMS_languageID")) = false then
      'no languages defined in tblLanguages -> abort
      'redirectBrowser "default.asp?nodb=1"
    else
      'update default language
      SQLQuery = "UPDATE tblLanguages SET languageDefault = " & prepBoolean("true") & " AND languageOnline=" & prepBoolean("true") & " WHERE languageID = " & session(sessionPrefix & "aCMS_languageID") & ";"
      objConn.Execute SQLQuery
    end if
  end if
  Set lli_ds = nothing

  'error recording
  recordError err.number, err.description, err.source

End Sub

'=====================================================

Function htmlEncode(html_encode_str)
  'prepares input string for output to html
  if dMode <> true then on error resume next

  'html encode output to minimum zero length string
  htmlEncode = Server.HTMLEncode("" & html_encode_str)

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function jsEncode(jse_in)
  'prepares input string for output to JavaScript
  if dMode <> true then on error resume next

  jsEncode = replace(jse_in, """", "\""")
  jsEncode = replace(jsEncode, "'", "\'")
  jsEncode = replace(jsEncode, chr(10),"\n")


  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function returnHTML(rfh_fieldData)
  'returns html for table cell (ensures at least a space is returned)

  if dMode <> true then on error resume next
  if trim(rfh_fieldData) = "" or isNull(rfh_fieldData) or isEmpty(rfh_fieldData) then
    returnHTML = "&nbsp;"
  else
    returnHTML = rfh_fieldData
  end if

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function isSearchEngine()
  'detects if client is search engine
  if dMode <> true then on error resume next
  'declare var
  Dim ise_robots, ise_str, ise_i

  ' Setup array of robot identifiers (Comma separated)
  ise_robots = "Acoon,AltaVista,AnzwersCrawl,Arachnoidea,ArchitextSpider,ask jeeves,Dumbot,EZResult,GAIS Robot,gncwebbot,Googlebot,Gulliver,ia_archiver,Informant,Infoseek,inktomi,KIT_Fireball,lwp-trivial,Lycos_Spider,MantraAgent,MSIECrawler,MSNBOT,MuscatFerret,psbot,Scooter,search.at,Slurp,slysearch,SwissSearch,T-H-U-N-D-E-R-S-T-O-N-E,Ultraseek,VSE,WebCrawler,webwombat,wisenutbot,WiseWire,Xenu"
  ise_robots = lCase(ise_robots)
  ise_robots = split(ise_robots, ",")

  'get user agent
  ise_str = lCase(request.serverVariables("HTTP_USER_AGENT"))

  isSearchEngine = false
  for ise_i = 1 to uBound(ise_robots)
    if inStr(ise_str, ise_robots(ise_i)) > 0 then
      isSearchEngine = true
      exit for
    end if
  next 'i

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function form_returnValue(frv_s, frv_sVar)
  'returns form value for input string

  if dMode <> true then on error resume next

  'declare vars
  Dim frv_ar, frv_arKey, frv_arVal, frv_arTemp
  Dim frv_bI, frv_aI

  'exit if no string passed
  If isTextValid(frv_s) = false then exit function

  'split &
  frv_Ar = Split(frv_s, "&")
  ReDim frv_arKey(UBound(frv_Ar))
  ReDim frv_arVal(UBound(frv_Ar))

  'split vals by =
  For frv_bI = 0 To UBound(frv_Ar)
    frv_artemp = Split(frv_Ar(frv_bI), "=")
    frv_arKey(frv_bI) = frv_artemp(0)
    frv_arVal(frv_bI) = frv_artemp(1)
  Next

  'find element and return val
  For frv_aI = 0 To UBound(frv_arKey)
    If LCase(""&frv_arKey(frv_aI)) = LCase(""&frv_sVar) Then
      form_returnValue = frv_arVal(frv_aI)
        Exit Function
    End If
  Next

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function URLDecode(urld_strString)
  if dMode <> true then on error resume next

  'decodes URLEncoded string
  urld_strString = Replace(urld_strString, "%2F", "/")
  urld_strString = Replace(urld_strString, "%7C", "|")
  urld_strString = Replace(urld_strString, "%3F", "?")
  urld_strString = Replace(urld_strString, "%21", "!")
  urld_strString = Replace(urld_strString, "%40", "@")
  urld_strString = Replace(urld_strString, "%5C", "\")
  urld_strString = Replace(urld_strString, "%23", "#")
  urld_strString = Replace(urld_strString, "%24", "$")
  urld_strString = Replace(urld_strString, "%5E", "^")
  urld_strString = Replace(urld_strString, "%26", "&")
  urld_strString = Replace(urld_strString, "%25", "%")
  urld_strString = Replace(urld_strString, "%2A", "*")
  urld_strString = Replace(urld_strString, "%28", "(")
  urld_strString = Replace(urld_strString, "%29", ")")
  urld_strString = Replace(urld_strString, "%7D", "}")
  urld_strString = Replace(urld_strString, "%3A", ":")
  urld_strString = Replace(urld_strString, "%2C", ",")
  urld_strString = Replace(urld_strString, "%7B", "{")
  urld_strString = Replace(urld_strString, "%2B", "+")
  urld_strString = Replace(urld_strString, "%2E", ".")
  urld_strString = Replace(urld_strString, "%2D", "-")
  urld_strString = Replace(urld_strString, "%7E", "~")
  urld_strString = Replace(urld_strString, "%2D", "-")
  urld_strString = Replace(urld_strString, "%5B", "[")
  urld_strString = Replace(urld_strString, "%5F", "_")
  urld_strString = Replace(urld_strString, "%5D", "]")
  urld_strString = Replace(urld_strString, "%60", "`")
  urld_strString = Replace(urld_strString, "%3D", "=")
  urld_strString = Replace(urld_strString, "%27", "'")
  urld_strString = Replace(urld_strString, "+", " ")
  urld_strString = Replace(urld_strString, "%22", Chr(34))

  URLDecode = urld_strString

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Sub loadPageTemplate()
  'loads appropriate template for the site map as specified in Admin->Settings
  if dMode <> true then on error resume next

  'declare vars
  Dim lct_SQLQuery, lct_ds

  'set default val -> dynamic so set as now
  publishedDate = now()

  'has a template been loaded?
  if isNumberValid(templateID) = false OR templateID = 0 then
    '-> no - just get the first template available if possible

    lct_SQLQuery = "SELECT templateID, templateCode FROM tbltemplates;"
    Set lct_ds = objConn.Execute(lct_SQLQuery)

    'found one?
    if not lct_ds.EOF and not lct_ds.BOF then
      templateID = lct_ds("templateID")
      templateCode = lct_ds("templateCode")
    else
      ' no template found - default HTML page
      templateID = -1
      templateCode = "<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 4.01 Transitional//EN""" & vbcr & "        ""http://www.w3.org/TR/html4/loose.dtd"">" & vbcr & "<html>" & vbcr & "<head>" & vbcr & "	<title>[title]</title>" & vbcr & "</head>" & vbcr & "<body>" & vbcr & "[menu1]<hr>" & vbcr & "[heading]<br><br>" & vbcr & "[content]" & vbcr & "</body>" & vbcr & "</html>"


    end if

    'close rs
    lct_ds.Close

  else

    'build and execute sql
    lct_SQLQuery = "SELECT templateCode FROM tbltemplates WHERE templateID=" & templateID & ";"
    Set lct_ds = objConn.Execute(lct_SQLQuery)
    'any template found?
    if not lct_ds.EOF and not lct_ds.BOF then
      templateCode = lct_ds("templateCode")
    else
      lct_ds.close
      lct_SQLQuery = "SELECT templateID, templateCode FROM tbltemplates;"
      Set lct_ds = objConn.Execute(lct_SQLQuery)

      'found one?
      if not lct_ds.EOF and not lct_ds.BOF then
        templateID = lct_ds("templateID")
        templateCode = lct_ds("templateCode")
      else
        ' no template found - default HTML page
        templateID = -1
        templateCode = "<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 4.01 Transitional//EN""" & vbcr & "        ""http://www.w3.org/TR/html4/loose.dtd"">" & vbcr & "<html>" & vbcr & "<head>" & vbcr & "	<title>[title]</title>" & vbcr & "</head>" & vbcr & "<body>" & vbcr & "[menu1]<hr>" & vbcr & "[heading]<br><br>" & vbcr & "[content]" & vbcr & "</body>" & vbcr & "</html>"
      end if
    end if
    'close rs object
    lct_ds.Close

  end if


  'if we have a template make the changes
  if isNumberValid(templateID) = true then

    'insert content into template
    c_parentNames = contentHeading
    templateCode = insertContent(templateCode)

    'insert menu into template
    templateCode = insertMenu(templateCode)

  end if

  send templateCode

  'error recording
  recordError err.number, err.description, err.source

End Sub

'=====================================================

Sub loadContent(contentMode)
  'loads content for input content mode
  '-> this is one of the main subs used to load content details from the database

  if dMode <> true then on error resume next

  Dim lc_dbcontentID, lc_tmp, lc_tmp2

  if contentMode = 1 then ' *** View published page
    SQLQuery = "SELECT tblContent_published.contentID, tblContent_published.parentID, tblContent_published.contentLink, tblContent_published_languages.contentName, tblContent_published_languages.contentTitle, tblContent_published_languages.contentHeading, tblContent_published_languages.contentBody, tblContent_published_languages.metaKeywords, tblContent_published_languages.metaDescription, tblContent_published.publishedDate, tbltemplates.templateID, tbltemplates.templateCode FROM (tblContent_published INNER JOIN tblContent_published_languages ON tblContent_published.publishedContentID = tblContent_published_languages.publishedContentID) INNER JOIN tbltemplates ON tblContent_published_languages.templateID = tbltemplates.templateID WHERE tblContent_published.contentOnline=" & prepBoolean("True") & " AND tblContent_published.contentID=" & contentID & " AND tblContent_published_languages.languageID=" & session(sessionPrefix & "aCMS_languageID") & ";"

  elseIf contentMode = 2 then ' *** View historic page
    SQLQuery = "SELECT tblContent_history.contentID, tblContent_history.parentID, tblContent_history.contentLink, tblContent_history.publishedDate, tblContent_history_languages.contentName, tblContent_history_languages.contentTitle, tblContent_history_languages.contentHeading, tblContent_history_languages.contentBody, tblContent_history_languages.metaKeywords, tblContent_history_languages.metaDescription, tbltemplates.templateID, tbltemplates.templateCode FROM tbltemplates INNER JOIN (tblContent_history_languages INNER JOIN tblContent_history ON tblContent_history_languages.historyContentID = tblContent_history.historyContentID) ON tbltemplates.templateID = tblContent_history_languages.templateID WHERE (((tblContent_history.historyContentID)=" & contentID & ") AND ((tblContent_history_languages.languageID)=" & session(sessionPrefix & "aCMS_languageID") & "));"

  elseIf contentMode = 3 then ' *** View edited page
    SQLQuery = "SELECT tblContent.contentID, tblContent.parentID, tblContent.contentLink, tblContent_languages.contentName, tblContent_languages.contentTitle, tblContent_languages.contentHeading, tblContent_languages.contentBody, tblContent_languages.metaKeywords, tblContent_languages.metaDescription, tbltemplates.templateID, tbltemplates.templateCode FROM tbltemplates INNER JOIN (tblContent_languages INNER JOIN tblContent ON tblContent_languages.contentID = tblContent.contentID) ON tbltemplates.templateID = tblContent_languages.templateID WHERE (((tblContent_languages.contentID)=" & contentID & ") AND ((tblContent_languages.languageID)=" & session(sessionPrefix & "aCMS_languageID") & "));"

  end if
  Set ds = objConn.Execute(SQLQuery)
  if not ds.EOF and not ds.BOF then
    if isTextValid(ds("contentLink")) then
      lc_dbcontentID = ds("contentLink")
      ds.close
      Set ds = nothing
      redirectBrowser lc_dbcontentID
    end if
    lc_dbcontentID = ds("contentID")
    parentID = ds("parentID")
    templateID = ds("templateID")
    templateCode = ds("templateCode")
    metaKeywords = ds("metaKeywords") & ""
    metaDescription = ds("metaDescription") & ""
    contentName = ds("contentName") & ""
    contentTitle = ds("contentTitle") & ""
    contentHeading = ds("contentHeading") & ""
    contentBody = ds("contentBody") & ""
    if contentMode = 3 then
      publishedDate = formatDateTime(now(), 1) & " " & formatDateTime(now(), 3) & ""
    else
      if isDate(ds("publishedDate")) then
        publishedDate = formatDateTime(ds("publishedDate"), 1) & " " & formatDateTime(ds("publishedDate"), 3) & ""
      end if
    end if
  else
    ' check if doc was link
    if contentMode = 1 then ' *** View published page
      SQLQuery = "SELECT tblContent_published.contentLink FROM tblContent_published WHERE tblContent_published.contentOnline=" & prepBoolean("True") & " AND tblContent_published.contentID=" & contentID & ";"
    elseIf contentMode = 2 then ' *** View historic page
      SQLQuery = "SELECT tblContent_history.contentLink FROM tblContent_history WHERE tblContent_history.historyContentID;"
    elseIf contentMode = 3 then ' *** View edited page
      SQLQuery = "SELECT tblContent.contentLink FROM tblContent WHERE tblContent.contentID=" & contentID & ";"
    end if
    Set ds = objConn.execute(SQLQuery)
    if not ds.BOF AND not ds.EOF then
      lc_tmp = ds("contentLink")
      if isTextValid(ds("contentLink")) then redirectBrowser lc_tmp
    end if

    if contentID <> g_homePageID then
      contentID = g_homePageID
      ds.close
      loadlanguageID()
      loadContent contentMode
      exit sub
    else
      contentError = true
    end if
  end if
  ds.Close
  Set ds = Nothing

  ' Work out parent IDs
  c_parentIDs = getContentparentIDs(lc_dbcontentID)

  'insert content into template
  templateCode = insertContent(templateCode)

  'insert menu into template
  templateCode = insertMenu(templateCode)

  'output html
  send templateCode

  'error recording
  recordError err.number, err.description, err.source

end sub

'=====================================================

Function insertContent(ic_templateCode_in)
  'replaces template content tags with actual content/data
  if dMode <> true then on error resume next

  'declare vars
  Dim ic_templateCode_out, ic_tmp, ic_tmp2, ic_ds

  'get input template
  ic_templateCode_out = ic_templateCode_in

  'replace with data
  ic_templateCode_out = replace(ic_templateCode_out, "[content]", contentBody, 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[title]", contentTitle, 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[heading]", contentHeading, 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[metaKeywords]", metaKeywords, 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[metaDescription]", metaDescription, 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[publishedDate]", publishedDate, 1, -1, 1)

  ic_templateCode_out = replace(ic_templateCode_out, "[heading1]", nthField(c_parentNames, "|*&|", 1) & "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[heading2]", nthField(c_parentNames, "|*&|", 2) & "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[heading3]", nthField(c_parentNames, "|*&|", 3) & "", 1, -1, 1)
  ic_templateCode_out = repIace(ic_templateCode_out, "[heading4]", nthField(c_parentNames, "|*&|", 3) & "", 1, -1, 1)
  if inStr(ic_templateCode_out, "[page(") > 0 then ic_templateCode_out = insertPageContent(ic_templateCode_out)
  if inStr(ic_templateCode_out, "[random(") > 0 then ic_templateCode_out = insertRandomPageContent(ic_templateCode_out)


  ' Newsletter
  if inStr(1, ic_templateCode_out, "[newsletter]", 1) > 0 then
    ic_templateCode_out = replace(ic_templateCode_out, "[newsletter]", display_newsletterForm(), 1, -1, 1)
  end if

  ' languages
  if inStr(1, ic_templateCode_out, "[language", 1) > 0 then
    ic_templateCode_out = replace(ic_templateCode_out, "[languageName]", session(sessionPrefix & "aCMS_languageName"), 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language1]", languageselecter(1), 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language2]", languageselecter(2), 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language3]", languageselecter(3), 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language4]", languageselecter(4), 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language5]", languageselecter(5), 1, -1, 1)
  end if

  ' Style sheet
  if inStr(1, ic_templateCode_out, "[styleSheet]", 1) > 0 then
    ic_templateCode_out = replace(ic_templateCode_out, "[styleSheet]", findStyleSheet(), 1, -1, 1)
  end if

  ' Search form
  if inStr(1, ic_templateCode_out, "[search]", 1) > 0 then
    SQLQuery = "SELECT tblPrefs_pages_languages.pageTextItemsValues FROM tblPrefs_pages INNER JOIN tblPrefs_pages_languages ON tblPrefs_pages.prefPageID = tblPrefs_pages_languages.prefPageID WHERE (((tblPrefs_pages.itemName)='Search') AND ((tblPrefs_pages_languages.languageID)=" & session(sessionPrefix & "aCMS_languageID") & "));"
    Set ic_ds = objConn.execute(SQLQuery)
    if not ic_ds.BOF AND not ic_ds.EOF then
      ic_tmp = ic_ds("pageTextItemsValues")
      if isTextValid(ic_tmp) then
        ic_tmp = split(ic_tmp, "|**|")
        ic_tmp2 = ic_tmp(1)
        ic_tmp = ic_tmp2
        ic_tmp2 = ""
      else
        ic_tmp = "Search"
      end if
    end if
    ic_ds.close
    Set ic_ds = nothing
    if lCase(lookupPageName()) = "search.asp" then ic_tmp2 = searchQuery
    ic_templateCode_out = replace(ic_templateCode_out, "[search]", returnSearchForm(ic_tmp2, ic_tmp), 1, -1, 1)
  end if

  ic_templateCode_out = replace(ic_templateCode_out, "[date]", formatDateTime(now(), 1), 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[time]", formatDateTime(now(), 3), 1, -1, 1)


  'return updated template
  insertContent = ic_templateCode_out

  'error recording
  recordError err.number, err.description, err.source

End Function


Function insertContentBlank(ic_templateCode_in)
  'replaces template content tags with actual content/data
  if dMode <> true then on error resume next

  'declare vars
  Dim ic_templateCode_out, ic_tmp, ic_tmp2, ic_ds

  'get input template
  ic_templateCode_out = ic_templateCode_in

  'replace with data
  ic_templateCode_out = replace(ic_templateCode_out, "[content]", "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[title]", "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[heading]", "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[metaKeywords]", "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[metaDescription]", "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[publishedDate]", "", 1, -1, 1)

  ic_templateCode_out = replace(ic_templateCode_out, "[heading1]", "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[heading2]", "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[heading3]", "", 1, -1, 1)


  if inStr(ic_templateCode_out, "[page(") > 0 then ic_templateCode_out = insertPageContent(ic_templateCode_out)
  if inStr(ic_templateCode_out, "[random(") > 0 then ic_templateCode_out = insertRandomPageContent(ic_templateCode_out)


  ' newsletter
  if inStr(1, ic_templateCode_out, "[newsletter]", 1) > 0 then
    ic_templateCode_out = replace(ic_templateCode_out, "[newsletter]", "", 1, -1, 1)
  end if

  ' languages
  if inStr(1, ic_templateCode_out, "[language", 1) > 0 then
    ic_templateCode_out = replace(ic_templateCode_out, "[languageName]", "", 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language1]", "", 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language2]", "", 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language3]", "", 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language4]", "", 1, -1, 1)
    ic_templateCode_out = replace(ic_templateCode_out, "[language5]", "", 1, -1, 1)
  end if

  ' Style sheet
  if inStr(1, ic_templateCode_out, "[styleSheet]", 1) > 0 then
    ic_templateCode_out = replace(ic_templateCode_out, "[styleSheet]", "", 1, -1, 1)
  end if

  ' Search form
  if inStr(1, ic_templateCode_out, "[search]", 1) > 0 then
    ic_templateCode_out = replace(ic_templateCode_out, "[search]", "", 1, -1, 1)
  end if

  ic_templateCode_out = replace(ic_templateCode_out, "[date]", "", 1, -1, 1)
  ic_templateCode_out = replace(ic_templateCode_out, "[time]", "", 1, -1, 1)


  'return updated template
  insertContentBlank = ic_templateCode_out

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function insertPageContent(ipc_in)
  'inserts page content for input tag
  if dMode <> true then on error resume next

  Dim ipc_out:ipc_out = ipc_in
  Dim noPages:noPages = countFields(ipc_out, "[page(") - 1
  Dim ipc_i, pageID, ipc_startPos, ipc_endPos
  Dim ipc_SQLQuery, ipc_ds

  ipc_startPos = 1
  for ipc_i = 1 to noPages
    ' establish pageNo
    ipc_startPos = inStr(ipc_startPos, ipc_out, "[page(") + len("[page(")
    ipc_endPos = inStr(ipc_startPos, ipc_out, ")")
    pageID = mid(ipc_out, ipc_startPos, ipc_endPos-ipc_startPos)
    if isNumberValid(pageID) then
      ipc_SQLQuery = "SELECT tblContent_published_languages.contentBody FROM (tblContent_published INNER JOIN tblContent_published_languages ON tblContent_published.publishedContentID = tblContent_published_languages.publishedContentID) WHERE tblContent_published.contentOnline=" & prepBoolean("True") & " AND tblContent_published.contentID=" & pageID & " AND tblContent_published_languages.languageID=" & session(sessionPrefix & "aCMS_languageID") & ";"
      Set ipc_ds = objconn.execute(ipc_SQLQuery)
      if not ipc_ds.BOF AND not ipc_ds.EOF then
        ipc_out = replace(ipc_out, "[page(" & pageID & ")]", ipc_ds("contentBody"), 1, -1, 1)
      else
        ipc_out = replace(ipc_out, "[page(" & pageID & ")]", "", 1, -1, 1)
      end if
      ipc_ds.close
    end if
  next 'i
  Set ipc_ds = Nothing


  insertPageContent = ipc_out

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function insertRandomPageContent(irpc_in)
  'inserts random page content for input tag
  if dMode <> true then on error resume next

  Dim irpc_out:irpc_out = irpc_in
  Dim noPages:noPages = countFields(irpc_out, "[random(") - 1
  Dim irpc_i, irpc_j, pageID, pageIDA, irpc_startPos, irpc_endPos
  Dim irpc_SQLQuery, irpc_ds

  irpc_startPos = 1

  for irpc_i = 1 to noPages
    ' establish pageNo
    irpc_startPos = inStr(irpc_startPos, irpc_out, "[random(") + len("[random(")
    irpc_endPos = inStr(irpc_startPos, irpc_out, ")")
    pageID = mid(irpc_out, irpc_startPos, irpc_endPos-irpc_startPos)
    if isNumberValid(replace(replace(pageID, " ", ""), ",", "")) then
    pageIDA = split(pageID, ",")
    if uBound(pageIDA) > 0 then
      ' Pick random page
      randomize
      randomize
      irpc_j = int(((uBound(pageIDA)+1) * rnd))
      irpc_SQLQuery = "SELECT tblContent_published_languages.contentBody FROM (tblContent_published INNER JOIN tblContent_published_languages ON tblContent_published.publishedContentID = tblContent_published_languages.publishedContentID) WHERE tblContent_published.contentOnline=" & prepBoolean("True") & " AND tblContent_published.contentID=" & pageIDA(irpc_j) & " AND tblContent_published_languages.languageID=" & session(sessionPrefix & "aCMS_languageID") & ";"
      Set irpc_ds = objconn.execute(irpc_SQLQuery)
      if not irpc_ds.BOF AND not irpc_ds.EOF then
        irpc_out = replace(irpc_out, "[random(" & pageID & ")]", irpc_ds("contentBody"), 1, -1, 1)
      else
        irpc_out = replace(irpc_out, "[random(" & pageID & ")]", "", 1, -1, 1)
      end if
      irpc_ds.close
    end if
    end if
  next 'i
  Set irpc_ds = Nothing

  insertRandomPageContent = irpc_out

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function insertMenu(lm_templateCode_in)
  'replaces template menu tags with actual menu
  if dMode <> true then on error resume next

  'declare vars
  Dim lm_templateCode_out, lm_tmp2, lm_tmp3, lm_tmp4, lm_tmp5, lm_tmp6

  'get input template
  lm_templateCode_out = lm_templateCode_in

  'init temp var
  lm_tmp2 = ""
  'if submenu tag present, get into temp var
  if inStr(1, lm_templateCode_out, "[subMenu]", 1) > 0 then
    lm_tmp2 = listSubContent(0, 1, false)
  end if
  'replace tag in template with value
  lm_templateCode_out = replace(lm_templateCode_out, "[subMenu]", lm_tmp2 & "", 1, -1, 1)

  're-init temp var
  lm_tmp2 = ""
  'if menu1 tag present, get into temp var
  if inStr(1, lm_templateCode_out, "[menu1]", 1) > 0 then
    lm_tmp2 = listSubContent(0, 1, true)
  end if
  'replace tag in template with value
  lm_templateCode_out = replace(lm_templateCode_out, "[menu1]", lm_tmp2 & "", 1, -1, 1)


  're-init temp vars
  lm_tmp2 = ""
  lm_tmp3 = ""
  lm_tmp4 = ""
  lm_tmp5 = ""
  lm_tmp6 = ""

  'check for sub menu items menu2 , menu3, submenu2'
  if countFields(c_parentIDs, ",") > 0 then
    if inStr(1, lm_templateCode_out, "[subMenu2]", 1) > 0 then
      lm_tmp6 = listSubContent(nthField(c_parentIDs, ",", 1), 2, false)
    end if


    if contentID > 0 AND inStr(lm_templateCode_out, "[menu") > 0 then
      'if menu2 tag present, get sub vals
      if inStr(lm_templateCode_out, "[menu2]") > 0 AND countFields(c_parentIDs, ",") > 0 then
        lm_tmp2 = listSubContent(nthField(c_parentIDs, ",", 1), 2, true)
      end if
      'if menu3 tag present, get sub vals
      if inStr(lm_templateCode_out, "[menu3]") > 0 AND countFields(c_parentIDs, ",") > 1 then
        lm_tmp3 = listSubContent(nthField(c_parentIDs, ",", 2), 3, true)
      end if
      'if menu3 tag present, get sub vals
      if inStr(lm_templateCode_out, "[menu4]") > 0 AND countFields(c_parentIDs, ",") > 2 then
        lm_tmp3 = listSubContent(nthField(c_parentIDs, ",", 3), 4, true)
      end if
      'if menu3 tag present, get sub vals
      if inStr(lm_templateCode_out, "[menu5]") > 0 AND countFields(c_parentIDs, ",") > 3 then
        lm_tmp3 = listSubContent(nthField(c_parentIDs, ",", 4), 5, true)
      end if
    end if
  end if
  'replace menu2 + menu3 tags as appropriate
  lm_templateCode_out = replace(lm_templateCode_out, "[menu2]", lm_tmp2 & "", 1, -1, 1)
  lm_templateCode_out = replace(lm_templateCode_out, "[menu3]", lm_tmp3, 1, -1, 1)
  lm_templateCode_out = replace(lm_templateCode_out, "[menu4]", lm_tmp4, 1, -1, 1)
  lm_templateCode_out = replace(lm_templateCode_out, "[menu5]", lm_tmp5, 1, -1, 1)
  lm_templateCode_out = replace(lm_templateCode_out, "[subMenu2]", lm_tmp6 & "", 1, -1, 1)

  'return the template
  insertMenu = lm_templateCode_out

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function getChar(fno)
  'returns odd character for input param
  if dMode <> true then on error resume next

  Select Case fno
    case 0
      getChar = "0"
    Case 1
      getChar = "P"
    Case 2
      getChar = "S"
    Case 3
      getChar = "G"
    Case 4
      getChar = "E"
    Case 5
      getChar = "B"
    Case 6
      getChar = "F"
    Case 7
      getChar = "M"
    Case 8
      getChar = "K"
    Case 9
      getChar = "L"
    Case 10
      getChar = "V"
    Case 11
      getChar = "C"
    Case 12
      getChar = "H"
    Case 13
      getChar = "T"
    Case 14
      getChar = "X"
    Case 15
      getChar = "A"
    Case 16
      getChar = "I"
    Case 17
      getChar = "N"
    Case 18
      getChar = "Q"
    Case 19
      getChar = "U"
    Case 20
      getChar = "O"
    Case 21
      getChar = "D"
    Case 22
      getChar = "Z"
    Case 23
      getChar = "Y"
    Case 24
      getChar = "R"
    Case 25
      getChar = "W"
    Case 26
      getChar = "J"
  End Select

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function returnSQLFn(rm_fn, rm_field, rm_table)
  ' returns the min value for the field/table specified
  if dMode <> true then on error resume next

  Dim rm_SQLQuery, rm_ds

  'ensure we are actually getting a function passed
  if lstr(rm_fn,"max") = false and lstr(rm_fn,"min") = false and lstr(rm_fn,"count") = false then exit function

  'get the val
  rm_SQLQuery = "SELECT " & rm_fn & "(" & rm_field & ") AS FnVal FROM " & rm_table & ";"
  Set rm_ds = objConn.Execute(rm_SQLQuery)

  'were any records found?
  if not rm_ds.EOF AND not rm_ds.BOF then
    returnSQLFn = rm_ds("FnVal")
    if isTextValid(returnSQLFn) = false then returnSQLFn = 0
  else
    'just return 0
    returnSQLFn = 0
  end if

  'close and destroy rs
  rm_ds.close
  Set rm_ds = Nothing

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function convertSimpleTime(cst_in)
  if dMode <> true then on error resume next
  Dim cst_out
  if cst_in > 12 then
    cst_out = cst_in-12
  else
    cst_out = cst_in
  end if
  convertSimpleTime = cst_out

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function displayAmPm(dap_in)
  'displays am or pm for input 24 hour param
  if dMode <> true then on error resume next
  Dim dap_out
  if dap_in > 11 then
    dap_out = "pm"
  else
    dap_out = "am"
  end if
  displayAmPm = dap_out

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Sub n_loadEmailDetails(which)
  'loads email settings and details depending in input param
  if dMode <> true then on error resume next

  Dim dnf_SQLQuery, dnf_ds
  dnf_SQLQuery = "SELECT tblPrefs.websiteURL, tblPrefs_email.emailFromAddress, tblPrefs_email.newsletterRequireFirstName, tblPrefs_email.newsletterRequireSurname, tblPrefs_email.newsletterConfirmFormat, tblPrefs_email.newsletterConfirmSignup, tblPrefs_email.newsletterConfirmSubject, tblPrefs_email.newsletterConfirmBody, tblPrefs_email.newsletterWelcomeFormat, tblPrefs_email.newsletterWelcomeEmail, tblPrefs_email.newsletterWelcomeSubject, tblPrefs_email.newsletterWelcomeBody FROM tblPrefs, tblPrefs_email;"
  Set dnf_ds = objConn.execute(dnf_SQLQuery)
  if not dnf_ds.BOF AND not dnf_ds.EOF then
    n_websiteURL = dnf_ds("websiteURL")
    n_emailFromAddress = dnf_ds("emailFromAddress")
    n_newsletterRequireFirstName = cBoolean(dnf_ds("newsletterRequireFirstName"))
    n_newsletterRequireSurname = cBoolean(dnf_ds("newsletterRequireSurname"))
    n_newsletterConfirmSignup = cBoolean(dnf_ds("newsletterConfirmSignup"))
    n_newsletterWelcomeEmail = cBoolean(dnf_ds("newsletterWelcomeEmail"))
    if which = 1 then
      n_emailFormat = dnf_ds("newsletterConfirmFormat")
      n_emailSubject = dnf_ds("newsletterConfirmSubject")
      n_emailBody = dnf_ds("newsletterConfirmBody")
    else
      n_emailFormat = dnf_ds("newsletterWelcomeFormat")
      n_emailSubject = dnf_ds("newsletterWelcomeSubject")
      n_emailBody = dnf_ds("newsletterWelcomeBody")
    end if

  else
    n_newsletterRequireFirstName = true
    n_newsletterRequireSurname = true
    n_newsletterConfirmSignup = false
    n_newsletterWelcomeEmail = false
  end if
  dnf_ds.close
  Set dnf_ds = nothing

  'error recording
  recordError err.number, err.description, err.source

end sub

'=====================================================

Sub f_loadEmailDetails()
  'loads email from address
  if dMode <> true then on error resume next

  Dim fle_SQLQuery, fle_ds
  fle_SQLQuery = "SELECT emailFromAddress FROM tblPrefs_email;"
  Set fle_ds = objConn.execute(fle_SQLQuery)
  if not fle_ds.BOF AND not fle_ds.EOF then
    f_emailFromAddress = fle_ds("emailFromAddress")
  end if
  fle_ds.close
  Set fle_ds = nothing

  'error recording
  recordError err.number, err.description, err.source

end sub

'=====================================================

Function n_replacenewsletterTags(iData, fn, sn, em, cs, wu)
  'merges input newsletter tags
  if dMode <> true then on error resume next

  n_replacenewsletterTags = iData
  n_replacenewsletterTags = replace(n_replacenewsletterTags, "[firstName]", ""&fn, 1, -1, 1)
  n_replacenewsletterTags = replace(n_replacenewsletterTags, "[surname]", ""&sn, 1, -1, 1)
  n_replacenewsletterTags = replace(n_replacenewsletterTags, "[email]", ""&em, 1, -1, 1)
  n_replacenewsletterTags = replace(n_replacenewsletterTags, "[websiteURL]", ""&wu, 1, -1, 1)
  n_replacenewsletterTags = replace(n_replacenewsletterTags, "[confirmlink]", ""&wu&"newsletter.asp?a=1&e="&cs, 1, -1, 1)
  n_replacenewsletterTags = replace(n_replacenewsletterTags, "[unsubscribe]", ""&wu&"newsletter.asp?a=2&e="&cs, 1, -1, 1)

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function findStyleSheet()
  ' This function looks for <link href="inc/cms.css" rel="stylesheet" type="text/css">
  ' from the pages template
  if dMode <> true then on error resume next

  if not isTextValid(templateCode) then
    exit function
  end if

  Dim fss_startPos, fss_endPos

  fss_startPos = inStr(lCase(templateCode), "type=""text/css""")

  if fss_startPos > 0 then
    fss_startPos = inStrRev(templateCode, "<link ", fss_startPos)
    fss_startPos = inStr(fss_startPos, templateCode, "href=""") + len("href=""")
    fss_endPos = inStr(fss_startPos, templateCode, """")
    findStyleSheet = mid(templateCode, fss_startPos, fss_endPos-fss_startPos)
    if left(findStyleSheet, 4) = "inc/" then findStyleSheet = right(findStyleSheet, len(findStyleSheet)-4)
  end if

  if not isTextValid(findStyleSheet) OR inStr(lCase(findStyleSheet), ".css") = 0 then findStyleSheet = ""

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Function returnSearchForm(sQuery, buttonText)
  'loads search data into content string
  if dMode <> true then on error resume next

  'declare vars
  Dim rsf_out

  rsf_out = "<form method=""GET"" name=""search"" action=""search.asp"" onsubmit="""" style=""display: inline;"">" & _
  "<table cellspacing=""0"" cellpadding=""0"" border=""0"">" & _
  "<tr>" & _
  "<td><input name=""searchQuery"" value=""" & htmlEncode(sQuery) & """></td>" & _
  "<td><input type=""submit"" name=""go"" value=""" & buttonText & """ style=""width: 60px""></td>" & _
  "</tr></table>" & _
  "<input type=""hidden"" name=""submitted"" value=""true""></form>" & _
  "<br><br>"

  'return search form
  returnSearchForm = rsf_out

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function languageselecter(lMode)
  'builds language selector for input lMode
  '
  ' lMode reference
  ' 1 - Pop up window with flags
  ' 2 - Pop up window no flags
  ' 3 - List with flags
  ' 4 - List no flags
  ' 5 - Select list

  if dMode <> true then on error resume next

  Dim l_ds, l_URL, l_QS, l_i, l_ST

  l_URL = lookupPageName()
  l_QS = request.serverVariables("QUERY_STRING")
  if isTextValid(l_QS) then
    l_i = inStr(l_QS, "lang=")
    if l_i > 0 then l_QS = left(l_QS, l_i-1)
    if not isTextValid(l_QS) then
      l_URL = l_URL & "?lang="
    else
      if right(l_QS, 1) <> "&" then l_QS = l_QS & "&"
      l_URL = l_URL & "?" & l_QS & "lang="
    end if
  else
    l_URL = l_URL & "?lang="
  end if


  if lMode < 3 then ' Pop up windows/Lists - display text link to open window
    if lMode = 1 then languageselecter = "<img src=""img/" & session(sessionPrefix & "aCMS_languageImage") & """ width=""20"" align=""absmiddle"" vspace=""2"" hspace=""2"" border=""0"" alt=""" & session(sessionPrefix & "aCMS_languageName") & """>&nbsp;"
    languageselecter = languageselecter & "<a href=""JavaScript:void(0);"" onClick=""window.open('languageselect.asp?lang_URL=" & server.URLEncode(l_URL) & "&ss=[styleSheet]"
    if lMode = 1 then
      languageselecter = languageselecter & "&img=1"
    else
      languageselecter = languageselecter & "&img=0"
    end if

    languageselecter = languageselecter & "','sLang','toolbar=no,menubar=no,scrollbars=auto,width=550,height=350')"" class=""langSelect"">"

    if databaseType = 3 then
      SQLQuery = "SELECT selectText FROM tblLanguages WHERE languageOnline=" & prepBoolean("true") & " AND languageID=" & session(sessionPrefix & "aCMS_languageID") & " ORDER BY languageDefault DESC, languageName;"
    else
      SQLQuery = "SELECT selectText FROM tblLanguages WHERE languageOnline=" & prepBoolean("true") & " AND languageID=" & session(sessionPrefix & "aCMS_languageID") & " ORDER BY languageDefault, languageName;"
    end if
    Set l_ds = objConn.Execute(SQLQuery)
    if not l_ds.EOF and not l_ds.BOF then
      languageselecter = languageselecter & l_ds("selectText") & "</a>"
      l_ST = l_ds("selectText")
    else
      languageselecter = languageselecter & "Select Language</a>"
      l_ST = "Select Language"
    end if
    l_ds.close
    Set l_ds = nothing
    exit function
  end if


  if databaseType = 3 then
    SQLQuery = "SELECT tblLanguages.languageID, tblLanguages.languageName, tblLanguages.languageImage, tblLanguages.selectText FROM tblLanguages WHERE languageOnline=" & prepBoolean("true") & " ORDER BY languageDefault DESC, languageName;"
  else
    SQLQuery = "SELECT tblLanguages.languageID, tblLanguages.languageName, tblLanguages.languageImage, tblLanguages.selectText FROM tblLanguages WHERE languageOnline=" & prepBoolean("true") & " ORDER BY languageDefault, languageName;"
  end if
  Set l_ds = objConn.Execute(SQLQuery)
  if not l_ds.EOF and not l_ds.BOF then

    if lMode < 5 then ' Lists ***

      languageselecter = languageselecter & "<table border=""0"" class=""langTable"">"
      if isTextValid(l_ds("selectText")) then languageselecter = languageselecter & "<tr class=""langHead"">"


      if (lMode=1 OR lMode=3) then
        languageselecter = languageselecter & "<td colspan=""2"" class=""langCell"">" & l_ds("selectText") & "</td></tr>"
      else
        languageselecter = languageselecter & "<td class=""langCell"">" & l_ds("selectText") & "</td></tr>"
      end if

    else ' Menus ***

      languageselecter = "<script type=""text/javascript"" language=""javascript"">" & vbcr & "<!--" & vbcr & "  function lLang(lID) {" & vbcr & "    document.location.href = '" & l_URL & "' + lID;" & vbcr & "  }" & vbcr & "//-->" & vbcr & "</script>" & vbcr

      languageselecter = languageselecter & "<select onChange=""lLang(this[this.selectedIndex].value)"">" & vbcr

      if isTextValid(l_ST) AND lMode = 5 then languageselecter = languageselecter & l_ST

    end if

    l_i = 1
    do until l_ds.EOF
      if lMode < 5 then ' Lists ***
        languageselecter = languageselecter & "<tr class=""langRow" & l_i & """>"

        if (lMode=1 OR lMode=3) then
          if isTextValid(l_ds("languageImage")) then
            languageselecter = languageselecter & "<td width=""25"" align=""center"" class=""langCell""><a href=""" & l_URL & l_ds("languageID") & """><img src=""img/" & l_ds("languageImage") & """ width=""20"" align=""absmiddle"" vspace=""2"" hspace=""2"" border=""0"" alt=""" & l_ds("languageName") & """></a></td>"
          else
            languageselecter = languageselecter & "<td class=""langCell"">&nbsp;</td>"
          end if
          languageselecter = languageselecter & "<td class=""langCellB"">"
        else
          languageselecter = languageselecter & "<td class=""langCell"">"
        end if

        languageselecter = languageselecter & "<a href=""" & l_URL & l_ds("languageID") & """>" & l_ds("languageName") & "</a>"

        languageselecter = languageselecter & "</td></tr>"

      else ' Menus ***

        languageselecter = languageselecter & "<option value=""" & l_ds("languageID") & """"
        if cInt(session(sessionPrefix & "aCMS_languageID")) = l_ds("languageID") then languageselecter = languageselecter & " selected"
        languageselecter = languageselecter & ">" & l_ds("languageName") & "</option>"

      end if

      l_i = l_i + 1
      if l_i > 2 then l_i = 1
      l_ds.moveNext
    loop

    if lMode < 5 then ' Lists ***
      languageselecter = languageselecter & "</table>"
    else ' Menus ***
      languageselecter = languageselecter & "</select>"
    end if


  end if
  l_ds.close
  Set l_ds = nothing

  'error recording
  recordError err.number, err.description, err.source

end function

'=====================================================

Sub send(theData)
  if dMode <> true then on error resume next
  response.write theData

  'error recording
  recordError err.number, err.description, err.source

end Sub
Sub send3(theData)
  if dMode <> true then on error resume next
  response.write "<h3>" & theData & "</h3>"

  'error recording
  recordError err.number, err.description, err.source

end Sub
Sub sendE(theData)
  if dMode <> true then on error resume next

  response.write "<h3>[" & theData & "]</h3>"

  'error recording
  recordError err.number, err.description, err.source

end Sub

'=====================================================



%>