<%
'=====================================================
' Contains functions to encrypt/decrypt card numbers
'=====================================================
'
' Requires POLARCRYPTO.DLL version 2.5.1.0
'
' Register this control by using "regsvr32 polarcrypto.dll" in a command window
' on the machine your web site is running on
' You may need to have your ISP run regPolar.bat, which does this for you.
'
' WARNING - Editing these functions may lose your
' -------   encryption key, rendering your card number
'           data useless with absolutely no chance of
'           retrieval!
'=====================================================

Dim m_DBKey, ec_objConn, ec_ds, ec_SQLQuery

'=====================================================

Function prepCardNumber(pcn_cardNumber, pcn_ccProcessRealTime, pcn_ccProcessAtCheckout, pcn_ccProcessinStockOnly, pcn_orderinStock, pcn_paymentSuccessful, pcn_storeFullCardNumbers, pcn_encryptCardNumbers, pcn_partialCardNumberAfterSuccessfulOrder)
  'prepares output card number according to settings passed to function

  Dim pcn_cardNumberOut

  if pcn_ccProcessRealTime = false or pcn_ccProcessAtCheckout = false or (pcn_ccProcessinStockOnly = true and pcn_orderinStock = false) or pcn_paymentSuccessful = false then
    ' Order wasn't realtime

    'check if checkout payment was simply failed
    if pcn_paymentSuccessful = false and pcn_ccProcessAtCheckout = true then

      ' Order processed
      if pcn_storeFullCardNumbers = true then
        if pcn_encryptCardNumbers = true then
          Call encrypt(pcn_cardNumber, pcn_cardNumberOut)
        else
          pcn_cardNumberOut = pcn_cardNumber
        end if
      else
        ' Order Processed - store partial
        if pcn_encryptCardNumbers = true then
          Call encrypt(left(pcn_cardNumber, 6) & "..." & right(pcn_cardNumber, 3), pcn_cardNumberOut)
        else
          pcn_cardNumberOut = left(pcn_cardNumber, 6) & "..." & right(pcn_cardNumber, 3)
        end if
      end if

    else
      'payment successful
      if pcn_encryptCardNumbers = true then
        Call encrypt(pcn_cardNumber, pcn_cardNumberOut)
      else
        pcn_cardNumberOut = pcn_cardNumber
      end if
    end if
  else
    ' Order processed
    if pcn_storeFullCardNumbers = true and pcn_partialCardNumberAfterSuccessfulOrder = false then
      if pcn_encryptCardNumbers = true then
        Call encrypt(pcn_cardNumber, pcn_cardNumberOut)
      else
        pcn_cardNumberOut = pcn_cardNumber
      end if
    else
      ' Order Processed - store partial
      if pcn_encryptCardNumbers = true then
        Call encrypt(left(pcn_cardNumber, 6) & "..." & right(pcn_cardNumber, 3), pcn_cardNumberOut)
      else
        pcn_cardNumberOut = left(pcn_cardNumber, 6) & "..." & right(pcn_cardNumber, 3)
      end if
    end if
  end if

  prepCardNumber = pcn_cardNumberOut

  'error recording
  recordError err.number, err.description, err.source

End Function

'=====================================================

Function getDBKey()
  Set ec_ds = Server.CreateObject("ADODB.Recordset")
  ec_SQLQuery = "SELECT salt FROM tblPrefs;"
  ec_ds.Open ec_SQLQuery,objConn,3
  getDBKey = ec_ds("salt")
  getDBKey = deAscKey(getDBKey)
  ec_ds.close
  Set ec_ds = Nothing
End Function

'=====================================================

Sub setDBKey(theDBKey)
  Dim theDBKey2
  theDBKey2 = ascKey(theDBKey)
  ec_SQLQuery = "UPDATE tblPrefs SET salt = '" & theDBKey2 & "';"
  objConn.Execute ec_SQLQuery
End Sub

'=====================================================

Sub Encrypt(s, e)
  Dim strDesc, strEncryptedText, pcHash, pcKey
  Dim m_dbNoKey, k
  Dim ctlCrypto
  Dim pcDataOut
  Dim objData
  Dim pcDataIn
  m_DBKey = getDBKey()
  On Error Resume Next
  err.clear
  Set ctlCrypto = server.CreateObject("Crypto.Crypto")
  Set pcDataIn = server.CreateObject("Crypto.CryptoData")
  Set pcDataOut = server.CreateObject("Crypto.CryptoData")
  If Err <> 0 Then
    e = s
    Exit Sub
  End If
  s = Trim(s)
  e = Trim(e)
  If not isTextValid(m_DBKey) Then
    Set objData = ctlCrypto.GenerateRandomData(256)
    Set pcKey = ctlCrypto.DeriveKey(Cstr(dst("dciklm{shf4:3rhwpivts4lcxkrwivtesckofl3")), 1, 256)
    pcDataIn.FromString objData.ToString(3)
    Set pcDataOut = pcKey.Encrypt(pcDataIn)
    m_DBKey = pcDataOut.ToString(1)
    setDBKey m_DBKey
    Set pcKey = ctlCrypto.DeriveKey(objData.ToString(3), 1, 256)
  Else
    Set pcKey = ctlCrypto.DeriveKey(Cstr(dst("dciklm{shf4:3rhwpivts4lcxkrwivtesckofl3")), 1, 256)
    pcDataIn.FromString Cstr(m_dbKey),1
    Set pcDataOut = pcKey.Decrypt(pcDataIn)
    k = pcDataOut.ToString(3)
    Set pcKey = ctlCrypto.DeriveKey(Cstr(k), 1, 256)
  End If
  Set objData = ctlCrypto.GenerateRandomData(6)
  pcDataIn.FromString s & objData.ToString(3)
  Set pcDataOut = pcKey.Encrypt(pcDataIn)
  e = pcDataOut.ToString(1)
  pcKey.Destroy
  If Err <> 0 Then
    send "Error in encryption: " & CStr(Err.Number) & " was generated by " & Err.Source & " " & Err.Number & " " & Err.description
    e = s
    Exit Sub
  End If
  Set pcKey = Nothing
  Set pcDataOut = Nothing
  Set ctlCrypto = Nothing
  Set pcHash = Nothing
  Set pcKey = Nothing
End Sub

'=====================================================

Sub Decrypt(e, u)
  Dim strDesc, strEncryptedText, pcHash, ctlCrypto, pcDataIn, pcKey, pcDataOut, k
  m_DBKey = getDBKey()
  On Error Resume Next
  err.clear
  Set ctlCrypto = server.CreateObject("Crypto.Crypto")
  Set pcDataIn = server.CreateObject("Crypto.CryptoData")
  Set pcDataOut = server.CreateObject("Crypto.CryptoData")
  If Err <> 0 Then
    u = e
    Exit Sub
  End If
  if m_DBKey = "" then
    u = e
    Exit Sub
  end if
  Set pcKey = ctlCrypto.DeriveKey(Cstr(dst("dciklm{shf4:3rhwpivts4lcxkrwivtesckofl3")), 1, 256)
  pcDataIn.FromString Cstr(m_DBKey),1
  Set pcDataOut = pcKey.Decrypt(pcDataIn)
  k = pcDataOut.ToString(3)
  Set pcKey = ctlCrypto.DeriveKey(Cstr(k), 1, 256)
  pcDataIn.FromString Cstr(e), 1
  Set pcDataOut = pcKey.Decrypt(pcDataIn)
  pcKey.Destroy
  u = pcDataOut.ToString(3)
  u = Left(u, Len(u) - 6)
  If Err <> 0 Then
    u = e
    send "Error in decryption : " & CStr(Err.Number) & " was generated by " & Err.Source & " " & Err.Number & " " & Err.description
  End If
  Set pcDataIn = Nothing
  Set pcDataOut = Nothing
  Set pcKey = Nothing
  Set ctlCrypto = Nothing
End Sub

'=====================================================

Sub DecryptFast(e, u)
  Dim strDesc, strEncryptedText, pcHash, pcKey, k
  Set pcKey = ctlCrypto.DeriveKey(Cstr(dst("dciklm{shf4:3rhwpivts4lcxkrwivtesckofl3")), 1, 256)
  pcDataIn.FromString Cstr(m_DBKey),1
  Set pcDataOut = pcKey.Decrypt(pcDataIn)
  k = pcDataOut.ToString(3)
  Set pcKey = ctlCrypto.DeriveKey(Cstr(k), 1, 256)
  pcDataIn.FromString Cstr(e), 3
  Set pcDataOut = pcKey.Decrypt(pcDataIn)
  pcKey.Destroy
  u = pcDataOut.ToString(3)
  u = Left(u, Len(u) - 6)
  If Err <> 0 Then
    u = e
    send "Error in decryption : " & CStr(Err.Number) & " was generated by " & Err.Source & " " & Err.Number & " " & Err.description
  End If
End Sub

'=====================================================

Function ascKey(iKey)
  Dim oKey, ak_i, ak_j
  ak_j = len(iKey)
  if ak_j > 0 then
    for ak_i = 1 to ak_j
      oKey = oKey & minDigits(asc(mid(iKey, ak_i, 1)), 3)
    next ' ak_i
  end if
  ascKey = oKey
End function

'=====================================================

Function deAscKey(iKey)
  Dim oKey, ak_i, ak_j
  ak_j = len(iKey)
  if ak_j > 0 then
    for ak_i = 1 to ak_j step 3
      oKey = oKey & chr(mid(iKey, ak_i, 3))
    next ' ak_i
  end if
  deAscKey = oKey
End function

'=====================================================

Function dst(dsStr)
  Dim ds_x, ds_i, ds_tmp
  dsStr = StrReverse(dsStr)
  For ds_i = 1 To Len(dsStr)
    ds_x = mid(dsStr, ds_i, 1)
    ds_tmp = ds_tmp & Chr(Asc(ds_x)-1)
  Next
  dst = ds_tmp
End Function

'=====================================================

Function CheckEncryption()
  SQLQuery = "SELECT hashPasswords FROM tblPrefs;"
  Set ds = objConn.Execute(SQLQuery)
  If not ds.eof and not ds.bof then
    If cBoolean(ds("hashPasswords")) = true then
       CheckEncryption = true
    else
       CheckEncryption = false
    end if
  end if
  ds.close
  set ds = nothing
End function

'=====================================================

Function HashValue(textToHash)

  'Function to do a 1 way hash on values
  'for passwords and other data that you don't want back


  Dim pcfBinary, pcfHex
  pcfBinary = 3
  pcfHex = 1


  Dim c
  Set c = Server.CreateObject("Crypto.Crypto")
  Dim dataObj
  Set dataObj = Server.CreateObject("Crypto.CryptoData")
  Dim hexHashData
  Set hexHashData = Server.CreateObject("Crypto.CryptoData")


  If Err <> 0 then
    HashValue = "-1RIGNFUWEGKDMJOEQFUHFJUDFISDDFFGWS"
  end if

  dataObj.FromString textToHash, pcfBinary

  If Err = 0 Then

    Dim hashObj
    Set hashObj = c.CreateHash

    If hashObj.AddData(dataObj) = True Then
      Set hexHashData = hashObj.Value
      HashValue = hexHashData.ToString(pcfHex)

      If Err <> 0 Then
        HashValue = "-2WGFKIHD32UVNKASDSWFKHSSKGSD"
      End If

    Else
      HashValue = "-3WFGRKJBKFJHYWEGYKBUVSDLNDKBSDF"
    End If

  Else
    HashValue = "-4SDFVKJFDKJHBDFIUGFEQLNKFLNVDFKB"
  End If

End Function

'=====================================================

Function polarcryptoInstalled()
  'tests if polarcrypto is available
  polarcryptoInstalled = false
  Dim pi_i, pi_j
  pi_i = "42424242"
  pi_j = ""
  Call encrypt(pi_i, pi_j)
  if pi_i = pi_j then
    polarcryptoInstalled = false
  else
    polarcryptoInstalled = true
  end if
End Function

'=====================================================

if request.queryString("printVersion") = "1" then response.write "enCards.asp V2.3.2"

%>